=== modified file '.bzrignore'
--- .bzrignore	2009-04-01 14:40:05 +0000
+++ .bzrignore	2009-02-10 01:57:06 +0000
@@ -6,4 +6,3 @@
 build
 *.log
 _trial_temp
-loggerhead-memprofile

=== modified file 'NEWS'
--- NEWS	2009-05-28 22:48:45 +0000
+++ NEWS	2009-03-04 21:02:14 +0000
@@ -4,18 +4,13 @@
 dev [future]
 ---------------
 
-    - Add bug links in revision informations (Alexandre Garnier, #314052)
-
-    - Make sure that binary files aren't annotated. (Martin Albisetti,
-      #258848)
-
     - Loggerhead now serves bzr branches over HTTP and exposes the URL
-      to branch them. Addresses bug #240577. (Jonathan Lange)
+      to branch them. (Jonathan Lange)
 
     - Leading blank lines in commit messages no longer result in an
       empty summary. (Colin Watson)
 
-    - Added optional syntax highlighting to annotate view using
+    - Added syntax highlighting to annotate view using
       python-pygments.  Partially addresses bug #306631. (Peter Bui)
 
     - Convert newlines in commit messages to HTML line breaks for
@@ -23,102 +18,30 @@
       Bui)
 
     - serve-branches now errors if run behind a proxy without
-      paste.deploy installed. (Michael Hudson)
+      paste.deploy installed.
 
     - Loggerhead should now handle file and directory names that need
       URL escaping without crashing.
 
     - The start-loggerhead script properly sets the wsgi.url_scheme
-      from the server.webpath option. (neror, #260547)
+      from the server.webpath option. (neror)
 
     - The revision page defaults to unified style again, and can
-      convert to a side-by-side view using JavaScript. (Michael Hudson)
-
-    - Clean up and improve performance of the annotate view. (Michael
-      Hudson)
-
-    - Finish converting JavaScript from MooTools to YUI 3. (Michael
-      Hudson)
-
-    - Improve compatibility with IE 6. (Michael Hudson)
+      convert to a side-by-side view using Javascript.
 
     - Leading blank lines in commit messages no longer result in an
       empty summary. (Colin Watson)
 
-    - Clip long lines in side-by-side diff view. (Michael Hudson,
-      #334837)
-
     - The user-confusing "next" and "previous" links now read "older"
-      and "newer" respectively. (Michael Hudson, #297930)
-
-    - The annotate view now contains line number anchors. (Michael
-      Hudson)
-
-    - Fix inventory pages using "//" in links. (Michael Hudson, #329668)
-
-    - Fix problems viewing files and directories containing spaces and
-      other funny characters. (Peter Bui)
+      and "newer" respectively.
+
+    - The annotate view now contains line number anchors.
+
+    - The annotate view does syntax highlighting using the "pygments"
+      library.  (Peter Bui)
 
     - Changelog messages are now displayed with newlines preserved.
-      (Peter Bui, #273688)
-
-    - Offer a link to see the full file diffs for a file path. (Michael
-      Hudson, #333797)
-
-    - Fix annotate error caused by Pygments stripping trailing
-      whitespace. (Michael Hudson, #338762)
-
-    - Loggerhead can be installed as a Bazaar plugin and run by
-      'bzr serve --http'. (Martin Pool)
-
-    - Load parts of the changelog and revision pages via XMLHttpRequest
-      to improve performance. This adds a dependency on simplejson or
-      json. Partially addresses bug #253950. (Michael Hudson)
-
-    - Various improvements to the animation JavaScript. (Michael Hudson)
-
-    - Fix HTML content of source files being displayed unescaped when
-      Pygments was unavailable. (Michael Hudson, #344970)
-
-    - Fix serve-branches's path argument. (Michael Hudson, #353230)
-
-    - serve-branches now has an option, --use-cdn, to load YUI from
-      Yahoo!'s CDN. (Matt Nordhoff)
-
-    - Fix certain race conditions for loading bzr-search. (Robert
-      Collins, #334250)
-
-    - Fix errors when using serve-branches --log-folder or --user-dirs.
-      (It was calling config.get_option() incorrectly.) (Matt Nordhoff,
-      bug #361238)
-
-    - Move some caching from RAM to the disk, and other caching and
-      memory usage improvements. (Michael Hudson)
-
-    - Add a --cache-dir option to serve-branches to choose where to
-      place the SQL cache, and only create one temporary SQL dir per
-      process. (Matt Nordhoff, #358322)
-
-    - Replace homebrew memory profiling code with Dozer. (Paul Hummer)
-
-    - Use the branch's public_branch as the default suggested URL to
-      branch from (Matt Nordhoff, #369767)
-
-    - Fix a file descriptor leak (Matt Nordhoff, #370845)
-
-    - Use transport API internally, so it is possible to specify a remote 
-      URL to serve-branches. (Jelmer Vernooij, #371787)
-
-    - Fix internal server errors when using start-loggerhead. (Matt
-      Nordhoff, #375948)
-
-    - Fix annotating non-UTF-8 files when Pygments is disabled. (Matt
-      Nordhoff, #376957)
-
-    - Fix 'bzr serve --http' errors. (Matt Nordhoff, #377551)
-
-    - Fix serving branches over HTTP. (Matt Nordhoff, Jelmer Vernooij,
-      #380026)
+      (Peter Bui)
 
 1.10 [22Dec2008]
 ---------------

=== modified file 'README.txt'
--- README.txt	2009-03-17 22:31:42 +0000
+++ README.txt	2009-03-10 01:05:08 +0000
@@ -11,19 +11,15 @@
 GETTING STARTED
 ---------------
 
-Loggerhead depends on:
-
+Loggerhead depends on 
 1) SimpleTAL for templating.
-   On Ubuntu, `sudo apt-get install python-simpletal`
+   on Ubuntu package `sudo apt-get install python-simpletal`
    or download from http://www.owlfish.com/software/simpleTAL/download.html
-2) simplejson for producing JSON data.
-   On Ubuntu, `sudo apt-get install python-simplejson`
-   or use `easy_install simplejson`.
-3) Paste for the server. (You need version 1.2 or newer of Paste.)
-   On Ubuntu, `sudo apt-get install python-paste`
+2) Paste for the server. (You need version 1.2 or newer of Paste.) 
+   on Ubuntu package `sudo apt-get install python-paste`
    or use `easy_install Paste`
-4) Paste Deploy  (optional, needed when proxying through Apache)
-   On Ubuntu, `sudo apt-get install python-pastedeploy`
+3) Paste Deploy  (optional, needed when proxying through Apache)
+   on Ubuntu package `sudo apt-get install python-pastedeploy`
    or use `easy_install PasteDeploy`
 
 Then simply run the 'serve-branches' with the branch you want to

=== modified file '__init__.py'
--- __init__.py	2009-05-27 07:23:03 +0000
+++ __init__.py	2009-03-10 01:01:04 +0000
@@ -36,74 +36,53 @@
     import bzrlib
     from bzrlib.api import require_any_api
 
-    require_any_api(bzrlib, [(1, 11, 0), (1, 13, 0), (1, 15, 0)])
+    require_any_api(bzrlib, [(1, 11, 0), (1, 13, 0)])
+
+    # TODO: This should provide a new type of server that can be used by bzr
+    # serve, maybe through a registry, rather than overriding the command.  Though
+    # maybe we should keep the wrapper to work with older bzr releases, at least
+    # for a bit.
 
     # NB: Normally plugins should lazily load almost everything, but this
     # seems reasonable to have in-line here: bzrlib.commands and options are
     # normally loaded, and the rest of loggerhead won't be loaded until serve
     # --http is run.
         
-    # transport_server_registry was added in bzr 1.16. When we drop support for
-    # older releases, we can remove the code to override cmd_serve.
-
-    try:
-        from bzrlib.transport import transport_server_registry
-    except ImportError:
-        transport_server_registry = None
-
-    DEFAULT_HOST = '0.0.0.0'
+    import bzrlib.builtins
+    from bzrlib.commands import get_cmd_object, register_command
+    from bzrlib.option import Option
+
+    _original_command = get_cmd_object('serve')
+
     DEFAULT_PORT = 8080
-    HELP = ('Loggerhead web-based code viewer and server. (default port: %d)' %
-            (DEFAULT_PORT,))
-
-    def serve_http(transport, host=None, port=None, inet=None):
-        # loggerhead internal code will try to 'import loggerhead', so
-        # let's put it on the path
-        import os.path, sys
-        sys.path.append(os.path.dirname(__file__))
-
-        from loggerhead.apps.transport import BranchesFromTransportRoot
-        from loggerhead.config import LoggerheadConfig
-        from paste.httpexceptions import HTTPExceptionHandler
-        from paste.httpserver import serve
-        if host is None:
-            host = DEFAULT_HOST
-        if port is None:
-            port = DEFAULT_PORT
-        argv = ['--host', host, '--port', str(port), transport.base]
-        config = LoggerheadConfig(argv)
-        app = BranchesFromTransportRoot(transport, config)
-        app = HTTPExceptionHandler(app)
-        serve(app, host=host, port=port)
-
-    if transport_server_registry is not None:
-        transport_server_registry.register('http', serve_http, help=HELP)
-    else:
-        import bzrlib.builtins
-        from bzrlib.commands import get_cmd_object, register_command
-        from bzrlib.option import Option
-
-        _original_command = get_cmd_object('serve')
-
-        class cmd_serve(bzrlib.builtins.cmd_serve):
-            __doc__ = _original_command.__doc__
-
-            takes_options = _original_command.takes_options + [
-                Option('http', help=HELP)]
-
-            def run(self, *args, **kw):
-                if 'http' in kw:
-                    from bzrlib.transport import get_transport
-                    path = kw.get('directory', '.')
-                    port = kw.get('port', DEFAULT_PORT)
-                    # port might be an int already...
-                    if isinstance(port, basestring) and ':' in port:
-                        host, port = port.split(':')
-                    else:
-                        host = DEFAULT_HOST
-                    transport = get_transport(path)
-                    serve_http(transport, host, port)
+
+    class cmd_serve(bzrlib.builtins.cmd_serve):
+        __doc__ = _original_command.__doc__
+
+        takes_options = _original_command.takes_options + [
+            Option('http',
+                help='Run an http (Loggerhead) server to browse code, '
+                    'by default on port %s.' % DEFAULT_PORT)]
+
+        def run(self, *args, **kw):
+            if 'http' in kw:
+                # loggerhead internal code will try to 'import loggerhead', so
+                # let's put it on the path
+                import os.path, sys
+                sys.path.append(os.path.dirname(__file__))
+
+                from loggerhead.apps.filesystem import BranchesFromFileSystemRoot
+                from paste.httpexceptions import HTTPExceptionHandler
+                from paste.httpserver import serve
+                a = HTTPExceptionHandler(BranchesFromFileSystemRoot('.'))
+                port = kw.get('port', DEFAULT_PORT)
+                # port might be an int already...
+                if isinstance(port, basestring) and ':' in port:
+                    host, port = port.split(':')
                 else:
-                    super(cmd_serve, self).run(*args, **kw)
+                    host = '0.0.0.0'
+                serve(a, host=host, port=port)
+            else:
+                super(cmd_serve, self).run(*args, **kw)
 
-        register_command(cmd_serve)
+    register_command(cmd_serve)

=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2009-05-27 16:21:06 +0000
+++ loggerhead/apps/branch.py	2009-03-13 05:36:26 +0000
@@ -11,16 +11,15 @@
 from paste import httpexceptions
 
 from loggerhead.apps import static_app
-from loggerhead.controllers.annotate_ui import AnnotateUI
-from loggerhead.controllers.atom_ui import AtomUI
 from loggerhead.controllers.changelog_ui import ChangeLogUI
-from loggerhead.controllers.diff_ui import DiffUI
-from loggerhead.controllers.download_ui import DownloadUI
-from loggerhead.controllers.filediff_ui import FileDiffUI
 from loggerhead.controllers.inventory_ui import InventoryUI
+from loggerhead.controllers.annotate_ui import AnnotateUI
 from loggerhead.controllers.revision_ui import RevisionUI
 from loggerhead.controllers.revlog_ui import RevLogUI
+from loggerhead.controllers.atom_ui import AtomUI
+from loggerhead.controllers.download_ui import DownloadUI
 from loggerhead.controllers.search_ui import SearchUI
+from loggerhead.controllers.diff_ui import DiffUI
 from loggerhead.history import History
 from loggerhead import util
 
@@ -31,38 +30,33 @@
 
     def __init__(self, branch, friendly_name=None, config={},
                  graph_cache=None, branch_link=None, is_root=False,
-                 served_url=_DEFAULT, use_cdn=False):
+                 served_url=_DEFAULT):
         self.branch = branch
         self._config = config
         self.friendly_name = friendly_name
         self.branch_link = branch_link  # Currently only used in Launchpad
         self.log = logging.getLogger('loggerhead.%s' % friendly_name)
         if graph_cache is None:
-            graph_cache = bzrlib.lru_cache.LRUCache(10)
+            graph_cache = bzrlib.lru_cache.LRUCache()
         self.graph_cache = graph_cache
         self.is_root = is_root
         self.served_url = served_url
-        self.use_cdn = use_cdn
 
     def get_history(self):
-        file_cache = None
-        revinfo_disk_cache = None
+        _history = History(self.branch, self.graph_cache)
         cache_path = self._config.get('cachepath', None)
         if cache_path is not None:
             # Only import the cache if we're going to use it.
             # This makes sqlite optional
             try:
-                from loggerhead.changecache import (
-                    FileChangeCache, RevInfoDiskCache)
+                from loggerhead.changecache import FileChangeCache
             except ImportError:
                 self.log.debug("Couldn't load python-sqlite,"
                                " continuing without using a cache")
             else:
-                file_cache = FileChangeCache(cache_path)
-                revinfo_disk_cache = RevInfoDiskCache(cache_path)
-        return History(
-            self.branch, self.graph_cache, file_cache=file_cache,
-            revinfo_disk_cache=revinfo_disk_cache, cache_key=self.friendly_name)
+                _history.use_file_cache(
+                    FileChangeCache(_history, cache_path))
+        return _history
 
     def url(self, *args, **kw):
         if isinstance(args[0], list):
@@ -84,24 +78,16 @@
     def static_url(self, path):
         return self._static_url_base + path
 
-    def yui_url(self, path):
-        if self.use_cdn:
-            base = 'http://yui.yahooapis.com/3.0.0pr2/build/'
-        else:
-            base = self.static_url('/static/javascript/yui/build/')
-        return base + path
-
     controllers_dict = {
-        '+filediff': FileDiffUI,
-        '+revlog': RevLogUI,
         'annotate': AnnotateUI,
-        'atom': AtomUI,
         'changes': ChangeLogUI,
-        'diff': DiffUI,
-        'download': DownloadUI,
         'files': InventoryUI,
         'revision': RevisionUI,
+        '+revlog': RevLogUI,
+        'download': DownloadUI,
+        'atom': AtomUI,
         'search': SearchUI,
+        'diff': DiffUI,
         }
 
     def last_updated(self):
@@ -109,7 +95,7 @@
         change = h.get_changes([h.last_revid])[0]
         return change.date
 
-    def public_branch_url(self):
+    def branch_url(self):
         return self.branch.get_config().get_user_option('public_branch')
 
     def app(self, environ, start_response):
@@ -119,16 +105,7 @@
             self._static_url_base = self._url_base
         self._environ = environ
         if self.served_url is _DEFAULT:
-            public_branch = self.public_branch_url()
-            if public_branch is not None:
-                self.served_url = public_branch
-            else:
-                # Loggerhead only supports serving .bzr/ on local branches, so
-                # we shouldn't suggest something that won't work.
-                if self.branch.base.startswith('file://'):
-                    self.served_url = self.url([])
-                else:
-                    self.served_url = None
+            self.served_url = self.url([])
         path = request.path_info_pop(environ)
         if not path:
             raise httpexceptions.HTTPMovedPermanently(

=== modified file 'loggerhead/apps/config.py'
--- loggerhead/apps/config.py	2009-05-13 13:14:04 +0000
+++ loggerhead/apps/config.py	2008-12-15 21:23:24 +0000
@@ -108,17 +108,20 @@
                 friendly_name = history.get_config().get_nickname()
                 if friendly_name is None:
                     friendly_name = view_name
-            branch_url = self._get_branch_url(view, view_config, view_name)
-            description = self._get_description(view, view_config, history)
             self.view_data_by_name[view_name] = {
                 'branch_path': folder,
-                'config': view_config,
-                'description': description,
+                'args': (view_name, view_config, self.graph_cache),
+                'description': self._get_description(view,
+                                                     view_config,
+                                                     history),
+                '_src_folder': folder,
+                '_view_config': view_config,
                 'friendly_name': friendly_name,
-                'graph_cache': self.graph_cache,
                 'name': view_name,
-                'served_url': branch_url,
                 }
+            branch_url = self._get_branch_url(view, view_config, view_name)
+            if branch_url is not None:
+                self.view_data_by_name[view_name]['branch_url'] = branch_url
             self.view_names.append(view_name)
         finally:
             b.unlock()
@@ -129,13 +132,12 @@
             return None
         view_data = view_data.copy()
         branch_path = view_data.pop('branch_path')
-        description = view_data.pop('description')
-        name = view_data.pop('name')
+        args = view_data.pop('args')
         b = bzrlib.branch.Branch.open(branch_path)
         b.lock_read()
-        view = BranchWSGIApp(b, **view_data)
-        view.description = description
-        view.name = name
+        view = BranchWSGIApp(b, *args)
+        for k in view_data:
+            setattr(view, k, view_data[k])
         return view
 
     def call(self, environ, start_response):

=== renamed file 'loggerhead/apps/transport.py' => 'loggerhead/apps/filesystem.py'
--- loggerhead/apps/transport.py	2009-05-25 01:03:25 +0000
+++ loggerhead/apps/filesystem.py	2009-02-19 18:04:11 +0000
@@ -1,6 +1,9 @@
-"""Serve branches at urls that mimic a transport's file system layout."""
-
-from bzrlib import branch, errors, lru_cache, urlutils
+"""Serve branches at urls that mimic the file system layout."""
+
+import os
+import tempfile
+
+from bzrlib import branch, errors, lru_cache
 
 from paste.request import path_info_pop
 from paste import httpexceptions
@@ -8,30 +11,28 @@
 
 from loggerhead.apps.branch import BranchWSGIApp
 from loggerhead.apps import favicon_app, static_app
-from loggerhead.config import LoggerheadConfig
 from loggerhead.controllers.directory_ui import DirectoryUI
 
-
-class BranchesFromTransportServer(object):
-
-    def __init__(self, transport, root, name=None):
-        self.transport = transport
+sql_dir = tempfile.mkdtemp(prefix='loggerhead-cache-')
+
+
+class BranchesFromFileSystemServer(object):
+
+    def __init__(self, path, root, name=None):
+        self.path = path
         self.root = root
         self.name = name
-        self._config = root._config
 
     def app_for_branch(self, branch):
         if not self.name:
-            name = branch._get_nick(local=True)
+            name = branch.get_config().get_nickname()
             is_root = True
         else:
             name = self.name
             is_root = False
         branch_app = BranchWSGIApp(
-            branch, name,
-            {'cachepath': self._config.SQL_DIR},
-            self.root.graph_cache, is_root=is_root,
-            use_cdn=self._config.get_option('use_cdn'))
+            branch, name, {'cachepath': sql_dir}, self.root.graph_cache,
+            is_root=is_root)
         return branch_app.app
 
     def app_for_non_branch(self, environ):
@@ -45,33 +46,32 @@
             else:
                 name = '/'
             return DirectoryUI(environ['loggerhead.static.url'],
-                               self.transport,
+                               self.path,
                                name)
         else:
-            new_transport = self.transport.clone(segment)
+            new_path = os.path.join(self.path, segment)
             if self.name:
-                new_name = urlutils.join(self.name, segment)
+                new_name = os.path.join(self.name, segment)
             else:
                 new_name = '/' + segment
-            return BranchesFromTransportServer(new_transport, self.root, new_name)
+            return BranchesFromFileSystemServer(new_path, self.root, new_name)
 
     def __call__(self, environ, start_response):
+        if not os.path.isdir(self.path):
+            raise httpexceptions.HTTPNotFound()
         try:
-            b = branch.Branch.open_from_transport(self.transport)
+            b = branch.Branch.open(self.path)
         except errors.NotBranchError:
-            if not self.transport.listable() or not self.transport.has('.'):
-                raise httpexceptions.HTTPNotFound()
             return self.app_for_non_branch(environ)(environ, start_response)
         else:
             return self.app_for_branch(b)(environ, start_response)
 
 
-class BranchesFromTransportRoot(object):
+class BranchesFromFileSystemRoot(object):
 
-    def __init__(self, transport, config):
-        self.graph_cache = lru_cache.LRUCache(10)
-        self.transport = transport
-        self._config = config
+    def __init__(self, folder):
+        self.graph_cache = lru_cache.LRUCache()
+        self.folder = folder
 
     def __call__(self, environ, start_response):
         environ['loggerhead.static.url'] = environ['SCRIPT_NAME']
@@ -82,31 +82,23 @@
         elif environ['PATH_INFO'] == '/favicon.ico':
             return favicon_app(environ, start_response)
         elif '/.bzr/' in environ['PATH_INFO']:
-            # TODO: Use something here that uses the transport API 
-            # rather than relying on the local filesystem API.
-            try:
-                path = urlutils.local_path_from_url(self.transport.base)
-            except errors.InvalidURL:
-                raise httpexceptions.HTTPNotFound()
-            else:
-                app = urlparser.make_static(None, path)
-                return app(environ, start_response)
+            app = urlparser.make_static(None, self.folder)
+            return app(environ, start_response)
         else:
-            return BranchesFromTransportServer(
-                self.transport, self)(environ, start_response)
-
-
-class UserBranchesFromTransportRoot(object):
-
-    def __init__(self, transport, config):
-        self.graph_cache = lru_cache.LRUCache(10)
-        self.transport = transport
-        self._config = config
-        self.trunk_dir = config.get_option('trunk_dir')
+            return BranchesFromFileSystemServer(
+                self.folder, self)(environ, start_response)
+
+
+class UserBranchesFromFileSystemRoot(object):
+
+    def __init__(self, folder, trunk_dir):
+        self.graph_cache = lru_cache.LRUCache()
+        self.folder = folder
+        self.trunk_dir = trunk_dir
 
     def __call__(self, environ, start_response):
         environ['loggerhead.static.url'] = environ['SCRIPT_NAME']
-        path_info = environ['PATH_INFO']
+        path_info= environ['PATH_INFO']
         if path_info.startswith('/static/'):
             segment = path_info_pop(environ)
             assert segment == 'static'
@@ -117,10 +109,10 @@
             # segments starting with ~ are user branches
             if path_info.startswith('/~'):
                 segment = path_info_pop(environ)
-                new_transport = self.transport.clone(segment[1:])
-                return BranchesFromTransportServer(
-                    new_transport, self, segment)(environ, start_response)
+                new_path = os.path.join(self.folder, segment[1:])
+                return BranchesFromFileSystemServer(
+                    new_path, self, segment)(environ, start_response)
             else:
-                new_transport = self.transport.clone(self.trunk_dir)
-                return BranchesFromTransportServer(
-                    new_transport, self)(environ, start_response)
+                new_path = os.path.join(self.folder, self.trunk_dir)
+                return BranchesFromFileSystemServer(
+                    new_path, self)(environ, start_response)

=== modified file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	2009-05-02 14:01:05 +0000
+++ loggerhead/changecache.py	2008-10-24 02:26:05 +0000
@@ -17,63 +17,46 @@
 #
 
 """
-a cache for chewed-up 'file change' data structures, which are basically just
-a different way of storing a revision delta.  the cache improves lookup times
-10x over bazaar's xml revision structure, though, so currently still worth
-doing.
+a cache for chewed-up "change" data structures, which are basically just a
+different way of storing a revision.  the cache improves lookup times 10x
+over bazaar's xml revision structure, though, so currently still worth doing.
 
 once a revision is committed in bazaar, it never changes, so once we have
 cached a change, it's good forever.
 """
 
 import cPickle
-import marshal
 import os
-import tempfile
-import zlib
+
+from loggerhead import util
+from loggerhead.lockfile import LockFile
+
+with_lock = util.with_lock('_lock', 'ChangeCache')
 
 try:
     from sqlite3 import dbapi2
 except ImportError:
     from pysqlite2 import dbapi2
 
-# We take an optimistic approach to concurrency here: we might do work twice
-# in the case of races, but not crash or corrupt data.
-
-def safe_init_db(filename, init_sql):
-    # To avoid races around creating the database, we create the db in
-    # a temporary file and rename it into the ultimate location.
-    fd, temp_path = tempfile.mkstemp(dir=os.path.dirname(filename))
-    os.close(fd)
-    con = dbapi2.connect(temp_path)
-    cur = con.cursor()
-    cur.execute(init_sql)
-    con.commit()
-    con.close()
-    os.rename(temp_path, filename)
 
 class FakeShelf(object):
 
     def __init__(self, filename):
         create_table = not os.path.exists(filename)
-        if create_table:
-            safe_init_db(
-                filename, "create table RevisionData "
-                "(revid binary primary key, data binary)")
         self.connection = dbapi2.connect(filename)
         self.cursor = self.connection.cursor()
+        if create_table:
+            self._create_table()
 
-    def _create_table(self, filename):
-        con = dbapi2.connect(filename)
-        cur = con.cursor()
-        cur.execute(
+    def _create_table(self):
+        self.cursor.execute(
             "create table RevisionData "
             "(revid binary primary key, data binary)")
-        con.commit()
-        con.close()
+        self.connection.commit()
 
     def _serialize(self, obj):
-        return dbapi2.Binary(cPickle.dumps(obj, protocol=2))
+        r = dbapi2.Binary(cPickle.dumps(obj, protocol=2))
+        return r
 
     def _unserialize(self, data):
         return cPickle.loads(str(data))
@@ -87,72 +70,49 @@
         else:
             return self._unserialize(filechange[0])
 
-    def add(self, revid, object):
-        try:
+    def add(self, revid_obj_pairs):
+        for (r, d) in revid_obj_pairs:
             self.cursor.execute(
                 "insert into revisiondata (revid, data) values (?, ?)",
-                (revid, self._serialize(object)))
-            self.connection.commit()
-        except dbapi2.IntegrityError:
-            # If another thread or process attempted to set the same key, we
-            # assume it set it to the same value and carry on with our day.
-            pass
+                (r, self._serialize(d)))
+        self.connection.commit()
 
 
 class FileChangeCache(object):
 
-    def __init__(self, cache_path):
+    def __init__(self, history, cache_path):
+        self.history = history
 
         if not os.path.exists(cache_path):
             os.mkdir(cache_path)
 
         self._changes_filename = os.path.join(cache_path, 'filechanges.sql')
 
-    def get_file_changes(self, entry):
+        # use a lockfile since the cache folder could be shared across
+        # different processes.
+        self._lock = LockFile(os.path.join(cache_path, 'filechange-lock'))
+
+    @with_lock
+    def get_file_changes(self, entries):
+        out = []
+        missing_entries = []
+        missing_entry_indices = []
         cache = FakeShelf(self._changes_filename)
-        changes = cache.get(entry.revid)
-        if changes is None:
-            changes = self.history.get_file_changes_uncached(entry)
-            cache.add(entry.revid, changes)
-        return changes
-
-
-class RevInfoDiskCache(object):
-    """Like `RevInfoMemoryCache` but backed in a sqlite DB."""
-
-    def __init__(self, cache_path):
-        if not os.path.exists(cache_path):
-            os.mkdir(cache_path)
-        filename = os.path.join(cache_path, 'revinfo.sql')
-        create_table = not os.path.exists(filename)
-        if create_table:
-            safe_init_db(
-                filename, "create table Data "
-                "(key binary primary key, revid binary, data binary)")
-        self.connection = dbapi2.connect(filename)
-        self.cursor = self.connection.cursor()
-
-    def get(self, key, revid):
-        self.cursor.execute(
-            "select revid, data from data where key = ?", (dbapi2.Binary(key),))
-        row = self.cursor.fetchone()
-        if row is None:
-            return None
-        elif str(row[0]) != revid:
-            return None
-        else:
-            return marshal.loads(zlib.decompress(row[1]))
-
-    def set(self, key, revid, data):
-        try:
-            self.cursor.execute(
-                'delete from data where key = ?', (dbapi2.Binary(key), ))
-            blob = zlib.compress(marshal.dumps(data))
-            self.cursor.execute(
-                "insert into data (key, revid, data) values (?, ?, ?)",
-                map(dbapi2.Binary, [key, revid, blob]))
-            self.connection.commit()
-        except dbapi2.IntegrityError:
-            # If another thread or process attempted to set the same key, we
-            # don't care too much -- it's only a cache after all!
-            pass
+        for entry in entries:
+            changes = cache.get(entry.revid)
+            if changes is not None:
+                out.append(changes)
+            else:
+                missing_entries.append(entry)
+                missing_entry_indices.append(len(out))
+                out.append(None)
+        if missing_entries:
+            missing_changes = self.history.get_file_changes_uncached(
+                                  missing_entries)
+            revid_changes_pairs = []
+            for i, entry, changes in zip(
+                missing_entry_indices, missing_entries, missing_changes):
+                revid_changes_pairs.append((entry.revid, changes))
+                out[i] = changes
+            cache.add(revid_changes_pairs)
+        return out

=== removed file 'loggerhead/config.py'
--- loggerhead/config.py	2009-06-02 13:26:49 +0000
+++ loggerhead/config.py	1970-01-01 00:00:00 +0000
@@ -1,85 +0,0 @@
-'''Configuration tools for Loggerhead.'''
-from optparse import OptionParser
-import sys
-import tempfile
-
-
-_temporary_sql_dir = None
-
-def _get_temporary_sql_dir():
-    global _temporary_sql_dir
-    if _temporary_sql_dir is None:
-        _temporary_sql_dir = tempfile.mkdtemp(prefix='loggerhead-cache-')
-    return _temporary_sql_dir
-
-def command_line_parser():
-    parser = OptionParser("%prog [options] <path>")
-    parser.set_defaults(
-        user_dirs=False,
-        show_version=False,
-        log_folder=None,
-        use_cdn=False,
-        sql_dir=None,
-        )
-    parser.add_option("--user-dirs", action="store_true", dest="user_dirs",
-                      help="Serve user directories as ~user.")
-    parser.add_option("--trunk-dir", metavar="DIR",
-                      help="The directory that contains the trunk branches.")
-    parser.add_option("--port", dest="user_port",
-                      help=("Port Loggerhead should listen on "
-                            "(defaults to 8080)."))
-    parser.add_option("--host", dest="user_host",
-                      help="Host Loggerhead should listen on.")
-    parser.add_option('--memory-profile', action='store_true',
-                      dest='memory_profile',
-                      help='Profile the memory usage using Dozer.')
-    parser.add_option("--prefix", dest="user_prefix",
-                      help="Specify host prefix.")
-    parser.add_option("--profile", action="store_true", dest="profile",
-                      help="Generate callgrind profile data to "
-                        "%d-stats.callgrind on each request.")
-    parser.add_option("--reload", action="store_true", dest="reload",
-                      help="Restarts the application when changing python"
-                           " files. Only used for development purposes.")
-    parser.add_option('--log-folder', dest="log_folder",
-                      type=str, help="The directory to place log files in.")
-    parser.add_option("--version", action="store_true", dest="show_version",
-                      help="Print the software version and exit")
-    parser.add_option('--use-cdn', action='store_true',
-                      help="Serve YUI from Yahoo!'s CDN")
-    parser.add_option('--cache-dir', dest='sql_dir',
-                      help="The directory to place the SQL cache in")
-    return parser
-
-
-class LoggerheadConfig(object):
-    '''A configuration object.'''
-
-    def __init__(self, argv=None):
-        if argv is None:
-            argv = sys.argv[1:]
-        self._parser = command_line_parser()
-        self._options, self._args = self._parser.parse_args(argv)
-
-        sql_dir = self.get_option('sql_dir')
-        if sql_dir is None:
-            sql_dir = _get_temporary_sql_dir()
-        self.SQL_DIR = sql_dir
-
-    def get_option(self, option):
-        '''Get an option from the options dict.'''
-        return getattr(self._options, option)
-
-    def get_arg(self, index):
-        '''Get an arg from the arg list.'''
-        return self._args[index]
-
-    def print_help(self):
-        '''Wrapper around OptionParser.print_help.'''
-        return self._parser.print_help()
-
-    @property
-    def arg_count(self):
-        '''Return the number of args from the option parser.'''
-        return len(self._args)
-

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2009-05-16 06:05:56 +0000
+++ loggerhead/controllers/annotate_ui.py	2009-03-06 20:36:09 +0000
@@ -17,13 +17,11 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import cgi
 import os
 import time
 
 import bzrlib.errors
 import bzrlib.textfile
-import bzrlib.osutils
 
 from paste.httpexceptions import HTTPBadRequest, HTTPServerError
 
@@ -49,17 +47,8 @@
 
         file_name = os.path.basename(self._history.get_path(revid, file_id))
 
-        file_text = tree.get_file_text(file_id)
-        encoding = 'utf-8'
-        try:
-            file_text = file_text.decode(encoding)
-        except UnicodeDecodeError:
-            encoding = 'iso-8859-15'
-            file_text = file_text.decode(encoding)
-
-        file_lines = bzrlib.osutils.split_lines(file_text)
-
-        try:
+        try:
+            file_lines = tree.get_file_lines(file_id)
             bzrlib.textfile.check_text_lines(file_lines)
         except bzrlib.errors.BinaryFile:
                 # bail out; this isn't displayable text
@@ -68,10 +57,10 @@
                                      change=util.Container())
         else:
             if highlight is not None:
-                hl_lines = highlight(file_name, file_text, encoding)
+                hl_lines = highlight(file_name, ''.join(file_lines))
                 hl_lines.extend([u''] * (len(file_lines) - len(hl_lines)))
             else:
-                hl_lines = map(cgi.escape, file_lines)
+                hl_lines = file_lines
 
             change_cache = {}
 

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2009-03-17 22:38:57 +0000
+++ loggerhead/controllers/changelog_ui.py	2009-03-16 23:01:40 +0000
@@ -17,13 +17,9 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import simplejson
 import urllib
 
-try:
-    import simplejson
-except ImportError:
-    import json as simplejson
-
 from paste.httpexceptions import HTTPServerError
 
 from loggerhead import util

=== modified file 'loggerhead/controllers/directory_ui.py'
--- loggerhead/controllers/directory_ui.py	2009-05-28 13:56:43 +0000
+++ loggerhead/controllers/directory_ui.py	2008-12-05 18:52:44 +0000
@@ -18,9 +18,9 @@
 
 import datetime
 import logging
-import stat
+import os
 
-from bzrlib import branch, errors
+from bzrlib import branch
 
 from loggerhead import util
 from loggerhead.controllers import TemplatedBranchView
@@ -48,7 +48,7 @@
 
     template_path = 'loggerhead.templates.directory'
 
-    def __init__(self, static_url_base, transport, name):
+    def __init__(self, static_url_base, path, name):
 
         class _branch(object):
             context_url = 1
@@ -58,26 +58,23 @@
                 return self._static_url_base + path
         self._branch = _branch
         self._history_callable = lambda:None
+        self._path = path
         self._name = name
         self._static_url_base = static_url_base
-        self.transport = transport
         self.log = logging.getLogger('')
 
     def get_values(self, path, kwargs, response):
-        listing = [d for d in self.transport.list_dir('.')
-                   if not d.startswith('.')]
+        listing = [d for d in os.listdir(self._path)
+                   if not d.startswith('.')
+                   and os.path.isdir(os.path.join(self._path, d))]
         listing.sort(key=lambda x: x.lower())
         dirs = []
         parity = 0
         for d in listing:
+            p = os.path.join(self._path, d)
             try:
-                b = branch.Branch.open_from_transport(self.transport.clone(d))
+                b = branch.Branch.open(p)
             except:
-                try:
-                    if not stat.S_ISDIR(self.transport.stat(d).st_mode):
-                        continue
-                except errors.NoSuchFile:
-                    continue
                 b = None
             dirs.append(DirEntry(d, parity, b))
             parity = 1 - parity

=== removed file 'loggerhead/controllers/filediff_ui.py'
--- loggerhead/controllers/filediff_ui.py	2009-03-28 14:26:37 +0000
+++ loggerhead/controllers/filediff_ui.py	1970-01-01 00:00:00 +0000
@@ -1,95 +0,0 @@
-from StringIO import StringIO
-import urllib
-
-from bzrlib import diff
-from bzrlib import errors
-from bzrlib import osutils
-
-from loggerhead import util
-from loggerhead.controllers import TemplatedBranchView
-
-def _process_diff(difftext):
-    chunks = []
-    chunk = None
-    for line in difftext.splitlines():
-        if len(line) == 0:
-            continue
-        if line.startswith('+++ ') or line.startswith('--- '):
-            continue
-        if line.startswith('@@ '):
-            # new chunk
-            if chunk is not None:
-                chunks.append(chunk)
-            chunk = util.Container()
-            chunk.diff = []
-            split_lines = line.split(' ')[1:3]
-            lines = [int(x.split(',')[0][1:]) for x in split_lines]
-            old_lineno = lines[0]
-            new_lineno = lines[1]
-        elif line.startswith(' '):
-            chunk.diff.append(util.Container(old_lineno=old_lineno,
-                                             new_lineno=new_lineno,
-                                             type='context',
-                                             line=line[1:]))
-            old_lineno += 1
-            new_lineno += 1
-        elif line.startswith('+'):
-            chunk.diff.append(util.Container(old_lineno=None,
-                                             new_lineno=new_lineno,
-                                             type='insert', line=line[1:]))
-            new_lineno += 1
-        elif line.startswith('-'):
-            chunk.diff.append(util.Container(old_lineno=old_lineno,
-                                             new_lineno=None,
-                                             type='delete', line=line[1:]))
-            old_lineno += 1
-        else:
-            chunk.diff.append(util.Container(old_lineno=None,
-                                             new_lineno=None,
-                                             type='unknown',
-                                             line=repr(line)))
-    if chunk is not None:
-        chunks.append(chunk)
-    return chunks
-
-
-def diff_chunks_for_file(repository, file_id, compare_revid, revid):
-    lines = {}
-    args = []
-    for r in (compare_revid, revid):
-        if r == 'null:':
-            lines[r] = []
-        else:
-            args.append((file_id, r, r))
-    for r, bytes_iter in repository.iter_files_bytes(args):
-        lines[r] = osutils.split_lines(''.join(bytes_iter))
-    buffer = StringIO()
-    try:
-        diff.internal_diff('', lines[compare_revid], '', lines[revid], buffer)
-    except errors.BinaryFile:
-        difftext = ''
-    else:
-        difftext = buffer.getvalue()
-
-    return _process_diff(difftext)
-
-
-class FileDiffUI(TemplatedBranchView):
-
-    template_path = 'loggerhead.templates.filediff'
-
-    def get_values(self, path, kwargs, headers):
-        history = self._history
-
-        revid = urllib.unquote(self.args[0])
-        compare_revid = urllib.unquote(self.args[1])
-        file_id = urllib.unquote(self.args[2])
-
-        repository = self._history._branch.repository
-        chunks = diff_chunks_for_file(
-            self._history._branch.repository, file_id, compare_revid, revid)
-
-        return {
-            'util': util,
-            'chunks': chunks,
-        }

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2009-03-19 00:44:05 +0000
+++ loggerhead/controllers/inventory_ui.py	2009-03-03 20:43:12 +0000
@@ -146,7 +146,8 @@
                 revno_url = 'head:'
             else:
                 revno_url = history.get_revno(revid)
-            history.add_branch_nicks(change)
+            # add parent & merge-point branch-nick info, in case it's useful
+            history.get_branch_nicks([ change ])
 
             # Create breadcrumb trail for the path within the branch
             branch_breadcrumbs = util.branch_breadcrumbs(path, rev_tree, 'files')

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2009-04-29 19:55:16 +0000
+++ loggerhead/controllers/revision_ui.py	2009-03-17 02:19:20 +0000
@@ -17,29 +17,158 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-try:
-    import simplejson
-except ImportError:
-    import json as simplejson
-import urllib
+from StringIO import StringIO
+
+import bzrlib.diff
+from bzrlib import errors
 
 from paste.httpexceptions import HTTPServerError
 
 from loggerhead import util
 from loggerhead.controllers import TemplatedBranchView
-from loggerhead.controllers.filediff_ui import diff_chunks_for_file
+from loggerhead.history import rich_filename
 
 
 DEFAULT_LINE_COUNT_LIMIT = 3000
 
-def dq(p):
-    return urllib.quote(urllib.quote(p, safe=''))
-
 
 class RevisionUI(TemplatedBranchView):
 
     template_path = 'loggerhead.templates.revision'
 
+    def _process_diff(self, diff):
+        # doesn't really need to be a method; could be static.
+        chunks = []
+        chunk = None
+        for line in diff.splitlines():
+            if len(line) == 0:
+                continue
+            if line.startswith('+++ ') or line.startswith('--- '):
+                continue
+            if line.startswith('@@ '):
+                # new chunk
+                if chunk is not None:
+                    chunks.append(chunk)
+                chunk = util.Container()
+                chunk.diff = []
+                split_lines = line.split(' ')[1:3]
+                lines = [int(x.split(',')[0][1:]) for x in split_lines]
+                old_lineno = lines[0]
+                new_lineno = lines[1]
+            elif line.startswith(' '):
+                chunk.diff.append(util.Container(old_lineno=old_lineno,
+                                                 new_lineno=new_lineno,
+                                                 type='context',
+                                                 line=line[1:]))
+                old_lineno += 1
+                new_lineno += 1
+            elif line.startswith('+'):
+                chunk.diff.append(util.Container(old_lineno=None,
+                                                 new_lineno=new_lineno,
+                                                 type='insert', line=line[1:]))
+                new_lineno += 1
+            elif line.startswith('-'):
+                chunk.diff.append(util.Container(old_lineno=old_lineno,
+                                                 new_lineno=None,
+                                                 type='delete', line=line[1:]))
+                old_lineno += 1
+            else:
+                chunk.diff.append(util.Container(old_lineno=None,
+                                                 new_lineno=None,
+                                                 type='unknown',
+                                                 line=repr(line)))
+        if chunk is not None:
+            chunks.append(chunk)
+        return chunks
+
+    def _parse_diffs(self, old_tree, new_tree, delta, specific_path):
+        """
+        Return a list of processed diffs, in the format::
+
+            list(
+                filename: str,
+                file_id: str,
+                chunks: list(
+                    diff: list(
+                        old_lineno: int,
+                        new_lineno: int,
+                        type: str('context', 'delete', or 'insert'),
+                        line: str,
+                    ),
+                ),
+            )
+        """
+        process = []
+        out = []
+
+        def include_specific_path(path):
+            return specific_path == path
+        def include_all_paths(path):
+            return True
+        if specific_path:
+            include_path = include_specific_path
+        else:
+            include_path = include_all_paths
+
+        for old_path, new_path, fid, \
+            kind, text_modified, meta_modified in delta.renamed:
+            if text_modified and include_path(new_path):
+                process.append((old_path, new_path, fid, kind))
+        for path, fid, kind, text_modified, meta_modified in delta.modified:
+            if include_path(path):
+                process.append((path, path, fid, kind))
+        for path, fid, kind in delta.added:
+            if kind == 'file' and include_path(path):
+                process.append((path, path, fid, kind))
+        for path, fid, kind in delta.removed:
+            if kind == 'file' and include_path(path):
+                process.append((path, path, fid, kind))
+
+        process.sort(key=lambda x:x[1])
+
+        for old_path, new_path, fid, kind in process:
+            try:
+                old_lines = old_tree.get_file_lines(fid)
+            except errors.NoSuchId:
+                old_lines = []
+            try:
+                new_lines = new_tree.get_file_lines(fid)
+            except errors.NoSuchId:
+                new_lines = []
+            buffer = StringIO()
+            if old_lines != new_lines:
+                try:
+                    bzrlib.diff.internal_diff(old_path, old_lines,
+                                              new_path, new_lines, buffer)
+                except bzrlib.errors.BinaryFile:
+                    diff = ''
+                else:
+                    diff = buffer.getvalue()
+            else:
+                diff = ''
+            out.append(util.Container(
+                filename=rich_filename(new_path, kind), file_id=fid,
+                chunks=self._process_diff(diff)))
+
+        return out
+
+    def get_changes_with_diff(self, change, compare_revid, specific_path):
+        h = self._history
+        if compare_revid is None:
+            if change.parents:
+                compare_revid = change.parents[0].revid
+            else:
+                compare_revid = 'null:'
+
+        rev_tree1 = h._branch.repository.revision_tree(compare_revid)
+        rev_tree2 = h._branch.repository.revision_tree(change.revid)
+        delta = rev_tree2.changes_from(rev_tree1)
+
+        changes = h.parse_delta(delta)
+
+        return changes, self._parse_diffs(
+            rev_tree1, rev_tree2, delta, specific_path)
+
     def get_values(self, path, kwargs, headers):
         h = self._history
         revid = self.get_revid()
@@ -68,44 +197,11 @@
         util.fill_in_navigation(navigation)
 
         change = h.get_changes([revid])[0]
-
-        if compare_revid is None:
-            file_changes = h.get_file_changes(change)
-        else:
-            file_changes = h.file_changes_for_revision_ids(
-                compare_revid, change.revid)
-
         if path in ('', '/'):
             path = None
-
-        link_data = {}
-        path_to_id = {}
-        if path:
-            item = [x for x in file_changes.text_changes if x.filename == path][0]
-            diff_chunks = diff_chunks_for_file(
-                self._history._branch.repository, item.file_id,
-                item.old_revision, item.new_revision)
-        else:
-            diff_chunks = None
-            for i, item in enumerate(file_changes.text_changes):
-                item.index = i
-                link_data['diff-' + str(i)] = '%s/%s/%s' % (
-                    dq(item.new_revision), dq(item.old_revision), dq(item.file_id))
-                path_to_id[item.filename] = 'diff-' + str(i)
-
-        h.add_branch_nicks(change)
-
-        if '.' in change.revno:
-            # Walk "down" though the merge-sorted graph until we find a
-            # revision with merge depth 0: this is the revision that merged
-            # this one to mainline.
-            ri = self._history._rev_info
-            i = self._history._rev_indices[change.revid]
-            while ri[i][0][2] > 0:
-                i += 1
-            merged_in = ri[i][0][3]
-        else:
-            merged_in = None
+        change.changes, diffs = self.get_changes_with_diff(change, compare_revid, path)
+        # add parent & merge-point branch-nick info, in case it's useful
+        h.get_branch_nicks([change])
 
         # Directory Breadcrumbs
         directory_breadcrumbs = (
@@ -118,17 +214,12 @@
             'branch': self._branch,
             'revid': revid,
             'change': change,
-            'file_changes': file_changes,
-            'diff_chunks': diff_chunks,
-            'link_data': simplejson.dumps(link_data),
+            'diffs': diffs,
             'specific_path': path,
-            'json_specific_path': simplejson.dumps(path),
-            'path_to_id': simplejson.dumps(path_to_id),
             'start_revid': start_revid,
             'filter_file_id': filter_file_id,
             'util': util,
             'history': h,
-            'merged_in': merged_in,
             'navigation': navigation,
             'query': query,
             'remember': remember,

=== modified file 'loggerhead/controllers/revlog_ui.py'
--- loggerhead/controllers/revlog_ui.py	2009-03-19 00:44:05 +0000
+++ loggerhead/controllers/revlog_ui.py	2009-03-16 23:01:40 +0000
@@ -13,14 +13,13 @@
 
         revid = urllib.unquote(self.args[0])
 
-        change = history.get_changes([revid])[0]
-        file_changes = history.get_file_changes(change)
-        history.add_branch_nicks(change)
+        changes = list(history.get_changes([revid]))
+        history.add_changes(changes)
+        history.get_branch_nicks(changes)
 
         return {
             'branch': self._branch,
-            'entry': change,
-            'file_changes': file_changes,
+            'entry': changes[0],
             'util': util,
             'revid': revid,
             'url': self._branch.context_url,

=== modified file 'loggerhead/highlight.py'
--- loggerhead/highlight.py	2009-05-16 06:03:47 +0000
+++ loggerhead/highlight.py	2009-03-06 13:19:38 +0000
@@ -24,13 +24,20 @@
 DEFAULT_PYGMENT_STYLE = 'colorful'
 
 
-def highlight(path, text, encoding, style=DEFAULT_PYGMENT_STYLE):
+def highlight(path, text, style=DEFAULT_PYGMENT_STYLE):
     """
     Returns a list of highlighted (i.e. HTML formatted) strings.
     """
 
     formatter = HtmlFormatter(style=style, nowrap=True, classprefix='pyg-')
 
+    encoding = 'utf-8'
+    try:
+        text = text.decode(encoding)
+    except UnicodeDecodeError:
+        encoding = 'iso-8859-15'
+        text = text.decode(encoding)
+
     try:
         lexer = guess_lexer_for_filename(path, text[:1024], encoding=encoding)
     except (ClassNotFound, ValueError):

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2009-05-28 22:48:45 +0000
+++ loggerhead/history.py	2009-03-06 20:43:13 +0000
@@ -34,6 +34,9 @@
 import re
 import textwrap
 import threading
+import time
+import urllib
+from StringIO import StringIO
 
 from loggerhead import search
 from loggerhead import util
@@ -41,10 +44,8 @@
 
 import bzrlib
 import bzrlib.branch
-import bzrlib.delta
 import bzrlib.diff
 import bzrlib.errors
-import bzrlib.lru_cache
 import bzrlib.progress
 import bzrlib.revision
 import bzrlib.textfile
@@ -128,89 +129,6 @@
     def __len__(self):
         return len(self.revid_list)
 
-class FileChangeReporter(object):
-    def __init__(self, old_inv, new_inv):
-        self.added = []
-        self.modified = []
-        self.renamed = []
-        self.removed = []
-        self.text_changes = []
-        self.old_inv = old_inv
-        self.new_inv = new_inv
-
-    def revid(self, inv, file_id):
-        try:
-            return inv[file_id].revision
-        except bzrlib.errors.NoSuchId:
-            return 'null:'
-
-    def report(self, file_id, paths, versioned, renamed, modified,
-               exe_change, kind):
-        if modified not in ('unchanged', 'kind changed'):
-            if versioned == 'removed':
-                filename = rich_filename(paths[0], kind[0])
-            else:
-                filename = rich_filename(paths[1], kind[1])
-            self.text_changes.append(util.Container(
-                filename=filename, file_id=file_id,
-                old_revision=self.revid(self.old_inv, file_id),
-                new_revision=self.revid(self.new_inv, file_id)))
-        if versioned == 'added':
-            self.added.append(util.Container(
-                filename=rich_filename(paths[1], kind),
-                file_id=file_id, kind=kind[1]))
-        elif versioned == 'removed':
-            self.removed.append(util.Container(
-                filename=rich_filename(paths[0], kind),
-                file_id=file_id, kind=kind[0]))
-        elif renamed:
-            self.renamed.append(util.Container(
-                old_filename=rich_filename(paths[0], kind[0]),
-                new_filename=rich_filename(paths[1], kind[1]),
-                file_id=file_id,
-                text_modified=modified == 'modified'))
-        else:
-            self.modified.append(util.Container(
-                filename=rich_filename(paths[1], kind),
-                file_id=file_id))
-
-
-class RevInfoMemoryCache(object):
-    """A store that validates values against the revids they were stored with.
-
-    We use a unique key for each branch.
-
-    The reason for not just using the revid as the key is so that when a new
-    value is provided for a branch, we replace the old value used for the
-    branch.
-
-    There is another implementation of the same interface in
-    loggerhead.changecache.RevInfoDiskCache.
-    """
-
-    def __init__(self, cache):
-        self._cache = cache
-
-    def get(self, key, revid):
-        """Return the data associated with `key`, subject to a revid check.
-
-        If a value was stored under `key`, with the same revid, return it.
-        Otherwise return None.
-        """
-        cached = self._cache.get(key)
-        if cached is None:
-            return None
-        stored_revid, data = cached
-        if revid == stored_revid:
-            return data
-        else:
-            return None
-
-    def set(self, key, revid, data):
-        """Store `data` under `key`, to be checked against `revid` on get().
-        """
-        self._cache[key] = (revid, data)
-
 
 class History (object):
     """Decorate a branch to provide information for rendering.
@@ -220,69 +138,13 @@
     around it, serve the request, throw the History object away, unlock the
     branch and throw it away.
 
-    :ivar _file_change_cache: An object that caches information about the
-        files that changed between two revisions.
-    :ivar _rev_info: A list of information about revisions.  This is by far
-        the most cryptic data structure in loggerhead.  At the top level, it
-        is a list of 3-tuples [(merge-info, where-merged, parents)].
-        `merge-info` is (seq, revid, merge_depth, revno_str, end_of_merge) --
-        like a merged sorted list, but the revno is stringified.
-        `where-merged` is a tuple of revisions that have this revision as a
-        non-lefthand parent.  Finally, `parents` is just the usual list of
-        parents of this revision.
-    :ivar _rev_indices: A dictionary mapping each revision id to the index of
-        the information about it in _rev_info.
-    :ivar _revno_revid: A dictionary mapping stringified revnos to revision
-        ids.
+    :ivar _file_change_cache: xx
     """
 
-    def _load_whole_history_data(self, caches, cache_key):
-        """Set the attributes relating to the whole history of the branch.
-
-        :param caches: a list of caches with interfaces like
-            `RevInfoMemoryCache` and be ordered from fastest to slowest.
-        :param cache_key: the key to use with the caches.
-        """
-        self._rev_indices = None
-        self._rev_info = None
-
-        missed_caches = []
-        def update_missed_caches():
-            for cache in missed_caches:
-                cache.set(cache_key, self.last_revid, self._rev_info)
-        for cache in caches:
-            data = cache.get(cache_key, self.last_revid)
-            if data is not None:
-                self._rev_info = data
-                update_missed_caches()
-                break
-            else:
-                missed_caches.append(cache)
-        else:
-            whole_history_data = compute_whole_history_data(self._branch)
-            self._rev_info, self._rev_indices = whole_history_data
-            update_missed_caches()
-
-        if self._rev_indices is not None:
-            self._revno_revid = {}
-            for ((_, revid, _, revno_str, _), _, _) in self._rev_info:
-                self._revno_revid[revno_str] = revid
-        else:
-            self._revno_revid = {}
-            self._rev_indices = {}
-            for ((seq, revid, _, revno_str, _), _, _) in self._rev_info:
-                self._rev_indices[revid] = seq
-                self._revno_revid[revno_str] = revid
-
-    def __init__(self, branch, whole_history_data_cache, file_cache=None,
-                 revinfo_disk_cache=None, cache_key=None):
+    def __init__(self, branch, whole_history_data_cache):
         assert branch.is_locked(), (
             "Can only construct a History object with a read-locked branch.")
-        if file_cache is not None:
-            self._file_change_cache = file_cache
-            file_cache.history = self
-        else:
-            self._file_change_cache = None
+        self._file_change_cache = None
         self._branch = branch
         self._inventory_cache = {}
         self._branch_nick = self._branch.get_config().get_nickname()
@@ -290,10 +152,17 @@
 
         self.last_revid = branch.last_revision()
 
-        caches = [RevInfoMemoryCache(whole_history_data_cache)]
-        if revinfo_disk_cache:
-            caches.append(revinfo_disk_cache)
-        self._load_whole_history_data(caches, cache_key)
+        whole_history_data = whole_history_data_cache.get(self.last_revid)
+        if whole_history_data is None:
+            whole_history_data = compute_whole_history_data(branch)
+            whole_history_data_cache[self.last_revid] = whole_history_data
+
+        (self._revision_graph, self._full_history, self._revision_info,
+         self._revno_revid, self._merge_sort, self._where_merged,
+         ) = whole_history_data
+
+    def use_file_cache(self, cache):
+        self._file_change_cache = cache
 
     @property
     def has_revisions(self):
@@ -303,12 +172,12 @@
         return self._branch.get_config()
 
     def get_revno(self, revid):
-        if revid not in self._rev_indices:
+        if revid not in self._revision_info:
             # ghost parent?
             return 'unknown'
-        seq = self._rev_indices[revid]
-        revno = self._rev_info[seq][0][3]
-        return revno
+        (seq, revid, merge_depth,
+         revno_str, end_of_merge) = self._revision_info[revid]
+        return revno_str
 
     def get_revids_from(self, revid_list, start_revid):
         """
@@ -316,17 +185,16 @@
         revid in revid_list.
         """
         if revid_list is None:
-            revid_list = [r[0][1] for r in self._rev_info]
+            revid_list = self._full_history
         revid_set = set(revid_list)
         revid = start_revid
 
         def introduced_revisions(revid):
             r = set([revid])
-            seq = self._rev_indices[revid]
-            md = self._rev_info[seq][0][2]
+            seq, revid, md, revno, end_of_merge = self._revision_info[revid]
             i = seq + 1
-            while i < len(self._rev_info) and self._rev_info[i][0][2] > md:
-                r.add(self._rev_info[i][0][1])
+            while i < len(self._merge_sort) and self._merge_sort[i][2] > md:
+                r.add(self._merge_sort[i][1])
                 i += 1
             return r
         while 1:
@@ -334,7 +202,7 @@
                 return
             if introduced_revisions(revid) & revid_set:
                 yield revid
-            parents = self._rev_info[self._rev_indices[revid]][2]
+            parents = self._revision_graph[revid]
             if len(parents) == 0:
                 return
             revid = parents[0]
@@ -348,9 +216,9 @@
             w = self._branch.repository.weave_store.get_weave(
                     file_id, self._branch.repository.get_transaction())
             w_revids = w.versions()
-            revids = [r for r in self._rev_indices if r in w_revids]
+            revids = [r for r in self._full_history if r in w_revids]
         except AttributeError:
-            possible_keys = [(file_id, revid) for revid in self._rev_indices]
+            possible_keys = [(file_id, revid) for revid in self._full_history]
             get_parent_map = self._branch.repository.texts.get_parent_map
             # We chunk the requests as this works better with GraphIndex.
             # See _filter_revisions_touching_file_id in bzrlib/log.py
@@ -551,10 +419,10 @@
 
         merge_point = []
         while True:
-            children = self._rev_info[self._rev_indices[revid]][1]
+            children = self._where_merged.get(revid, [])
             nexts = []
             for child in children:
-                child_parents = self._rev_info[self._rev_indices[child]][2]
+                child_parents = self._revision_graph[child]
                 if child_parents[0] == revid:
                     nexts.append(child)
                 else:
@@ -589,28 +457,31 @@
 
         return [d[revnos][1] for revnos in d.keys()]
 
-    def add_branch_nicks(self, change):
+    def get_branch_nicks(self, changes):
         """
-        given a 'change', fill in the branch nicks on all parents and merge
-        points.
+        given a list of changes from L{get_changes}, fill in the branch nicks
+        on all parents and merge points.
         """
         fetch_set = set()
-        for p in change.parents:
-            fetch_set.add(p.revid)
-        for p in change.merge_points:
-            fetch_set.add(p.revid)
+        for change in changes:
+            for p in change.parents:
+                fetch_set.add(p.revid)
+            for p in change.merge_points:
+                fetch_set.add(p.revid)
         p_changes = self.get_changes(list(fetch_set))
         p_change_dict = dict([(c.revid, c) for c in p_changes])
-        for p in change.parents:
-            if p.revid in p_change_dict:
-                p.branch_nick = p_change_dict[p.revid].branch_nick
-            else:
-                p.branch_nick = '(missing)'
-        for p in change.merge_points:
-            if p.revid in p_change_dict:
-                p.branch_nick = p_change_dict[p.revid].branch_nick
-            else:
-                p.branch_nick = '(missing)'
+        for change in changes:
+            # arch-converted branches may not have merged branch info :(
+            for p in change.parents:
+                if p.revid in p_change_dict:
+                    p.branch_nick = p_change_dict[p.revid].branch_nick
+                else:
+                    p.branch_nick = '(missing)'
+            for p in change.merge_points:
+                if p.revid in p_change_dict:
+                    p.branch_nick = p_change_dict[p.revid].branch_nick
+                else:
+                    p.branch_nick = '(missing)'
 
     def get_changes(self, revid_list):
         """Return a list of changes objects for the given revids.
@@ -655,6 +526,32 @@
 
         return [self._change_from_revision(rev) for rev in rev_list]
 
+    def _get_deltas_for_revisions_with_trees(self, revisions):
+        """Produce a list of revision deltas.
+
+        Note that the input is a sequence of REVISIONS, not revision_ids.
+        Trees will be held in memory until the generator exits.
+        Each delta is relative to the revision's lefthand predecessor.
+        (This is copied from bzrlib.)
+        """
+        required_trees = set()
+        for revision in revisions:
+            required_trees.add(revision.revid)
+            required_trees.update([p.revid for p in revision.parents[:1]])
+        trees = dict((t.get_revision_id(), t) for
+                     t in self._branch.repository.revision_trees(
+                         required_trees))
+        ret = []
+        for revision in revisions:
+            if not revision.parents:
+                old_tree = self._branch.repository.revision_tree(
+                    bzrlib.revision.NULL_REVISION)
+            else:
+                old_tree = trees[revision.parents[0].revid]
+            tree = trees[revision.revid]
+            ret.append(tree.changes_from(old_tree))
+        return ret
+
     def _change_from_revision(self, revision):
         """
         Given a bzrlib Revision, return a processed "change" for use in
@@ -667,41 +564,34 @@
 
         message, short_message = clean_message(revision.message)
 
-        try:
-            authors = revision.get_apparent_authors()
-        except AttributeError:
-            authors = [revision.get_apparent_author()]
-
         entry = {
             'revid': revision.revision_id,
             'date': commit_time,
-            'authors': authors,
+            'author': revision.get_apparent_author(),
             'branch_nick': revision.properties.get('branch-nick', None),
             'short_comment': short_message,
             'comment': revision.message,
             'comment_clean': [util.html_clean(s) for s in message],
             'parents': revision.parent_ids,
-            'bugs': [bug.split()[0] for bug in revision.properties.get('bugs', '').splitlines()],
         }
         return util.Container(entry)
 
-    def get_file_changes_uncached(self, entry):
-        repo = self._branch.repository
-        if entry.parents:
-            old_revid = entry.parents[0].revid
-        else:
-            old_revid = bzrlib.revision.NULL_REVISION
-        return self.file_changes_for_revision_ids(old_revid, entry.revid)
-
-    def get_file_changes(self, entry):
+    def get_file_changes_uncached(self, entries):
+        delta_list = self._get_deltas_for_revisions_with_trees(entries)
+
+        return [self.parse_delta(delta) for delta in delta_list]
+
+    def get_file_changes(self, entries):
         if self._file_change_cache is None:
-            return self.get_file_changes_uncached(entry)
+            return self.get_file_changes_uncached(entries)
         else:
-            return self._file_change_cache.get_file_changes(entry)
-
-    def add_changes(self, entry):
-        changes = self.get_file_changes(entry)
-        entry.changes = changes
+            return self._file_change_cache.get_file_changes(entries)
+
+    def add_changes(self, entries):
+        changes_list = self.get_file_changes(entries)
+
+        for entry, changes in zip(entries, changes_list):
+            entry.changes = changes
 
     def get_file(self, file_id, revid):
         "returns (path, filename, data)"
@@ -713,7 +603,7 @@
             path = '/' + path
         return path, inv_entry.name, rev_tree.get_file_text(file_id)
 
-    def file_changes_for_revision_ids(self, old_revid, new_revid):
+    def parse_delta(self, delta):
         """
         Return a nested data structure containing the changes in a delta::
 
@@ -723,24 +613,31 @@
             modified: list(
                 filename: str,
                 file_id: str,
-            ),
-            text_changes: list((filename, file_id)),
+            )
         """
-        repo = self._branch.repository
-        if bzrlib.revision.is_null(old_revid) or \
-               bzrlib.revision.is_null(new_revid):
-            old_tree, new_tree = map(
-                repo.revision_tree, [old_revid, new_revid])
-        else:
-            old_tree, new_tree = repo.revision_trees([old_revid, new_revid])
-
-        reporter = FileChangeReporter(old_tree.inventory, new_tree.inventory)
-
-        bzrlib.delta.report_changes(new_tree.iter_changes(old_tree), reporter)
-
-        return util.Container(
-            added=sorted(reporter.added, key=lambda x:x.filename),
-            renamed=sorted(reporter.renamed, key=lambda x:x.new_filename),
-            removed=sorted(reporter.removed, key=lambda x:x.filename),
-            modified=sorted(reporter.modified, key=lambda x:x.filename),
-            text_changes=sorted(reporter.text_changes, key=lambda x:x.filename))
+        added = []
+        modified = []
+        renamed = []
+        removed = []
+
+        for path, fid, kind in delta.added:
+            added.append(util.Container(
+                filename=rich_filename(path, kind), file_id=fid, kind=kind))
+
+        for path, fid, kind, text_modified, meta_modified in delta.modified:
+            modified.append(util.Container(
+                filename=rich_filename(path, kind), file_id=fid))
+
+        for old_path, new_path, fid, kind, text_modified, meta_modified in \
+                delta.renamed:
+            renamed.append(util.Container(
+                old_filename=rich_filename(old_path, kind),
+                new_filename=rich_filename(new_path, kind), file_id=fid,
+                text_modified=text_modified))
+
+        for path, fid, kind in delta.removed:
+            removed.append(util.Container(
+                filename=rich_filename(path, kind), file_id=fid, kind=kind))
+
+        return util.Container(added=added, renamed=renamed,
+                              removed=removed, modified=modified)

=== added file 'loggerhead/lockfile.py'
--- loggerhead/lockfile.py	1970-01-01 00:00:00 +0000
+++ loggerhead/lockfile.py	2008-10-24 02:26:05 +0000
@@ -0,0 +1,84 @@
+#
+# Copyright (C) 2006  Robey Pointer <robey@lag.net>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+
+import os
+import threading
+import time
+
+from loggerhead import util
+
+
+with_lock = util.with_lock('_tlock', 'LockFile')
+
+MAX_STALE_TIME = 5 * 60
+
+
+class LockFile (object):
+    """
+    simple lockfile implementation that mimics the API of threading.Lock, so
+    it can be used interchangably.  it's actually a reentrant lock, so the
+    lock may be acquired multiple times by the same thread, as long as it's
+    released an equal number of times.  unlike threading.Lock, this lock can
+    be used across processes.
+
+    this uses os.open(O_CREAT|O_EXCL), which apparently works even on windows,
+    but will not work over NFS, if anyone still uses that.  so don't put the
+    cache folder on an NFS server...
+    """
+
+    def __init__(self, filename):
+        self._filename = filename
+        # thread lock to maintain internal consistency
+        self._tlock = threading.Lock()
+        self._count = 0
+        if os.path.exists(filename):
+            # remove stale locks left over from a previous run
+            if time.time() - os.stat(filename).st_mtime > MAX_STALE_TIME:
+                os.remove(filename)
+
+    @with_lock
+    def _try_acquire(self):
+        if self._count > 0:
+            self._count += 1
+            return True
+        try:
+            fd = os.open(self._filename,
+                         os.O_WRONLY | os.O_CREAT | os.O_EXCL, 0600)
+            os.close(fd)
+            self._count += 1
+            return True
+        except OSError:
+            return False
+
+    def acquire(self):
+        # try over and over, sleeping on exponential backoff with
+        # an upper limit of about 5 seconds
+        pause = 0.1
+        #max_pause = 5.0
+        max_pause = 0.1
+        while True:
+            if self._try_acquire():
+                return
+            time.sleep(pause)
+            pause = min(pause * 2.0, max_pause)
+
+    @with_lock
+    def release(self):
+        self._count -= 1
+        if self._count == 0:
+            os.remove(self._filename)

=== modified file 'loggerhead/middleware/profile.py'
--- loggerhead/middleware/profile.py	2009-04-01 22:50:25 +0000
+++ loggerhead/middleware/profile.py	2008-11-14 06:48:20 +0000
@@ -1,11 +1,8 @@
 '''Profiling middleware for paste.'''
 import cgi
-import logging
-import sys
 import threading
 
 from bzrlib.lsprof import profile
-from guppy import hpy
 
 class LSProfMiddleware(object):
     '''Paste middleware for profiling with lsprof.'''
@@ -34,4 +31,3 @@
         finally:
             self.lock.release()
 
-

=== modified file 'loggerhead/search.py'
--- loggerhead/search.py	2009-04-17 01:50:05 +0000
+++ loggerhead/search.py	2008-11-05 00:50:06 +0000
@@ -17,17 +17,13 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
-_mod_index = None
-def import_search():
-    global errors, _mod_index, FileTextHit, RevisionHit
-    if _mod_index is not None:
-        return
-    try:
-        from bzrlib.plugins.search import errors
-        from bzrlib.plugins.search import index as _mod_index
-        from bzrlib.plugins.search.index import FileTextHit, RevisionHit
-    except ImportError:
-        _mod_index = None
+import sets
+try:
+    from bzrlib.plugins.search import errors
+    from bzrlib.plugins.search import index as _mod_index
+    from bzrlib.plugins.search.index import FileTextHit, RevisionHit
+except ImportError:
+    _mod_index = None
 
 
 def search_revisions(branch, query_list, suggest=False):
@@ -40,7 +36,6 @@
     param suggest: Optional flag to request suggestions instead of results
     return: A list for results, either revision ids or terms
     """
-    import_search()
     if _mod_index is None:
         return None # None indicates could-not-search
     try:
@@ -64,6 +59,6 @@
                     revid_list.append(result.text_key[1])
                 elif isinstance(result, RevisionHit):
                     revid_list.append(result.revision_key[0])
-            return list(set(revid_list))
+            return list(sets.Set(revid_list))
     finally:
         index._branch.unlock()

=== modified file 'loggerhead/static/css/diff.css'
--- loggerhead/static/css/diff.css	2009-05-30 17:40:05 +0000
+++ loggerhead/static/css/diff.css	2009-02-26 20:55:46 +0000
@@ -31,7 +31,7 @@
     width:493px;
     margin:0px 0px 5px 0px;
 }
-.information, .committer, .timer, .mfrom, .mto, .revid, .bug {
+.information, .committer, .timer, .mfrom, .mto, .revid {
     clear:both;
     margin:0px;
     padding:0px 0px 2px 18px;
@@ -65,14 +65,6 @@
 .mto {
     background:url(../images/ico_mergeto.gif) no-repeat top left;
 }
-.bug {
-    padding:1px 0px 0px 18px;
-    margin:0px 10px 5px 0px;
-    float:left;
-    clear:none;
-    display:inline;
-    background:url(../images/ico_bug.png) no-repeat top left;
-}
 /**/
 #loggerheadCont p.expand, #loggerheadCont p.expand a, #loggerheadCont p.expand a:link, #loggerheadCont p.expand a:visited, #loggerheadCont p.expand a:hover {
     color:#0f6b97;

=== modified file 'loggerhead/static/css/files.css'
--- loggerhead/static/css/files.css	2009-05-28 22:48:45 +0000
+++ loggerhead/static/css/files.css	2009-01-23 20:53:40 +0000
@@ -1,5 +1,5 @@
 /*Info Box*/
-.information, .committer, .timer, .mfrom, .mto, .revid, .bug {
+.information, .committer, .timer, .mfrom, .mto, .revid {
 	float:left;
 	margin:0px 10px 5px 0px;
 	padding:0px 0px 2px 18px;
@@ -39,6 +39,3 @@
     width:100%;
     position:relative;
 }
-.bug {
-	background:url(../images/ico_bug.png) no-repeat top left;
-}

=== removed file 'loggerhead/static/images/ico_bug.png'
Binary files loggerhead/static/images/ico_bug.png and loggerhead/static/images/ico_bug.png differ
=== modified file 'loggerhead/static/javascript/changelog.js'
--- loggerhead/static/javascript/changelog.js	2009-03-31 21:11:38 +0000
+++ loggerhead/static/javascript/changelog.js	2009-03-16 02:58:10 +0000
@@ -60,6 +60,7 @@
             open_node: item.query('.long_description'),
             close_node: item.query('.short_description'),
             source: global_path + '+revlog/' + revid,
+            source_target: item.query('.source_target'),
             loading: item.query('.loading'),
             is_open: false
           });

=== modified file 'loggerhead/static/javascript/custom.js'
--- loggerhead/static/javascript/custom.js	2009-04-01 15:28:21 +0000
+++ loggerhead/static/javascript/custom.js	2009-03-16 03:22:02 +0000
@@ -1,4 +1,6 @@
-Y = YUI().use("node", "io-base", "anim");
+Y = YUI().use("node", "io-base", "io-queue", "anim");
+
+Y.io.queue.size(2);
 
 var global_timeout_id = null;
 var global_search_request = null;
@@ -78,15 +80,12 @@
 function Collapsable(config)
 {
   this.is_open = config.is_open;
+  this.source_target = config.source_target;
   this.open_node = config.open_node;
   this.close_node = config.close_node;
   this.expand_icon = config.expand_icon;
   this.source = config.source;
   this.loading = config.loading;
-  this.node_process = config.node_process;
-  this.container = null;
-  this.anim = null;
-  this._loading = false;
 }
 
 function get_height(node) {
@@ -100,138 +99,71 @@
   return height;
 }
 
-Collapsable.prototype._animate = function (callback)
-{
-  if (this.anim) this.anim.stop();
-
-  this.anim = new Y.Anim(
-    {
-      node: this.container,
-      from: {
-        marginBottom: this.container.getStyle('marginBottom')
-      },
-      to: {
-        marginBottom: 0
-      },
-      duration: 0.2
-    });
-
-  this.anim.run();
-  this.anim.on('end', this.animComplete, this, callback);
-}
-
-Collapsable.prototype._load_finished = function(tid, res, args)
-{
-  var l = res.responseText.split('\n');
-  l.splice(0, 1);
-  var newNode = Y.Node.create(l.join(''));
-  if (this.node_process)
-    this.node_process(newNode);
+Collapsable.prototype._load_finished = function(tid, res)
+{
+  var newNode = Y.Node.create(res.responseText.split('\n').splice(1).join(''));
+  this.source_target.ancestor().replaceChild(newNode, this.source_target);
+  this.source_target = null;
   this.source = null;
-  newNode.setStyle('display', 'none');
-  this.loading.ancestor().insertBefore(newNode, this.loading);
-  var delta = this.loading.get('region').height - get_height(newNode);
-  newNode.setStyle('display', 'block');
-  this.container.setStyle('marginBottom', parseFloat(this.container.getStyle('marginBottom')) + delta);
-  this.loading.ancestor().removeChild(this.loading);
-  this._animate(args[0]);
+  this.loading.setStyle('display', 'none');
+  this.open();
 };
 
-Collapsable.prototype._ensure_container = function(callback)
-{
-  if (this.container == null) {
-    this.container = Y.Node.create('<div></div>');
-    if (this.closed_node) {
-      this.closed_node.ancestor().replaceChild(
-        this.container, this.closed_node);
-      this.container.appendChild(this.closed_node);
-      if (this.open_node) {
-        this.container.appendChild(this.open_node);
-      }
-    }
-    else {
-      this.open_node.ancestor().replaceChild(
-        this.container, this.open_node);
-      this.container.appendChild(this.open_node);
-    }
-    var outer = Y.Node.create('<div style="overflow:hidden;"></div>');
-    this.container.ancestor().replaceChild(outer, this.container);
-    outer.appendChild(this.container);
-  }
-}
-
-/* What happens when you click open.
- *
- * 1. The arrow flips to the expanded position.
- *
- * 2. If necessary, the div which will be running the animation is
- * created and the open/closed content stuffed into it (and has height
- * set to the height of the closed content).
- *
- * 3. The open content is shown and the closed content is closed.
- *
- * 4. The animation to expose all of the open content is started.
- *
- * 5. If we have to do ajax to load content, start the request.
- *
- * 6. When the request completes, parse the content into a node, run
- * the node_process callback over it and replace the spinner (assumed
- * to be appropriately contained in the open node) with the new node.
- *
- * 7. If the animation showing the open content has not completed,
- * stop it.
- *
- * 8. Start a new animation to show the rest of the new content.
- */
-
-Collapsable.prototype.open = function(callback)
-{
-  this.expand_icon.set('src', expanded_icon_path);
-
-  this._ensure_container();
-
-  var open_height = get_height(this.open_node);
-
-  var close_height;
-  if (this.close_node) {
-    close_height = this.close_node.get('region').height;
-  }
-  else {
-    close_height = 0;
-  }
-
-  this.container.setStyle('marginBottom', close_height - open_height);
-  if (this.close_node) {
-    this.close_node.setStyle('display', 'none');
-  }
-  this.open_node.setStyle('display', 'block');
-
-  this._animate(callback);
-
+Collapsable.prototype.open = function()
+{
   if (this.source) {
-    Y.io(
+    this.loading.setStyle('display', 'block');
+    Y.io.queue(
       this.source,
       {
         on: {complete: this._load_finished},
-        arguments: [callback],
         context: this
       });
     return;
   }
 
+  var open_height = get_height(this.open_node);
+
+  var close_height;
+  if (this.close_node) {
+    close_height = this.close_node.get('region').height;
+  }
+  else {
+    close_height = 0;
+  }
+
+  var container = this.open_node.ancestor('.container');
+
+  var anim = new Y.Anim(
+    {
+      node: container,
+      from: {
+        marginBottom: close_height - open_height
+      },
+      to: {
+        marginBottom: 0
+      },
+      duration: 0.2
+    });
+
+  anim.on('end', this.openComplete, this);
+  container.setStyle('marginBottom', close_height - open_height);
+  if (this.close_node) {
+    this.close_node.setStyle('display', 'none');
+  }
+  this.open_node.setStyle('display', 'block');
+  this.expand_icon.set('src', this.expand_icon.get('alt'));
+  anim.run();
 };
 
-Collapsable.prototype.animComplete = function(evt, callback)
+Collapsable.prototype.openComplete = function()
 {
-  this.anim = null;
-  if (this._loading) return;
-  if (callback) callback();
   this.is_open = true;
 };
 
 Collapsable.prototype.close = function()
 {
-  this._ensure_container();
+  var container = this.open_node.ancestor('.container');
 
   var open_height = this.open_node.get('region').height;
 
@@ -245,7 +177,7 @@
 
   var anim = new Y.Anim(
     {
-      node: this.container,
+      node: container,
       from: {
         marginBottom: 0
       },
@@ -263,8 +195,8 @@
   if (this.close_node) {
     this.close_node.setStyle('display', 'block');
   }
-  this.container.setStyle('marginBottom', 0);
-  this.expand_icon.set('src', collapsed_icon_path);
+  this.open_node.ancestor('.container').setStyle('marginBottom', 0);
+  this.expand_icon.set('src', this.expand_icon.get('title'));
   this.is_open = false;
 };
 

=== modified file 'loggerhead/static/javascript/diff.js'
--- loggerhead/static/javascript/diff.js	2009-03-31 21:11:38 +0000
+++ loggerhead/static/javascript/diff.js	2009-03-16 21:53:23 +0000
@@ -87,14 +87,13 @@
 
 function toggle_unified_sbs(event) {
   event.preventDefault();
-  var pts = Y.all(".pseudotable");
   if (unified) {
-    pts && pts.each(make_sbs);
+    Y.all(".pseudotable").each(make_sbs);
     unified = false;
     Y.get("#toggle_unified_sbs").set('innerHTML', "Show unified diffs");
   }
   else {
-    pts && pts.each(make_unified);
+    Y.all(".pseudotable").each(make_unified);
     unified = true;
     Y.get("#toggle_unified_sbs").set('innerHTML', "Show diffs side-by-side");
   }
@@ -104,7 +103,7 @@
 
 function toggle_expand_all_revisionview(action)
 {
-  var diffs = Y.all('.diff');
+  var diffs = Y.all('.diffBox');
   if (diffs == null) return;
   diffs.each(
     function(item, i)
@@ -143,62 +142,24 @@
   '#collapse_all a'
 );
 
-function node_process(node) {
-  if (!unified) {
-    node.get('children').filter('.pseudotable').each(make_sbs);
-  }
-}
-
-function zoom_to_diff (path) {
-  var collapsable = Y.get('#' + path_to_id[path]).collapsable;
-  if (!collapsable.is_open) {
-    collapsable.open(
-      function () {
-        window.location.hash = '#' + path;
-      });
-  }
-}
-
 Y.on(
   "domready", function () {
     Y.all(".show_if_js").removeClass("show_if_js");
-    if (!specific_path) {
-      Y.all("#list-files a").on(
-        'click',
-        function (e) {
-          e.preventDefault();
-          var path = decodeURIComponent(e.target.get('href').split('#')[1]);
-          window.location.hash = '#' + path;
-          zoom_to_diff(path);
-        });
-    }
-    var diffs = Y.all('.diff');
+    var diffs = Y.all('.diffBox');
     if (diffs == null) return;
     diffs.each(
       function(item, i)
       {
-        var source_url = null;
-        if (!specific_path)
-          source_url = global_path + '+filediff/' + link_data[item.get('id')];
-        item.query('.the-link').on(
-          'click',
-          function(e) {
-            e.preventDefault();
-            collapsable.toggle();
-          });
+        item.query('.expand_diff').on('click', function() { collapsable.toggle(); });
         var collapsable = new Collapsable(
           {
             expand_icon: item.query('.expand_diff'),
-            open_node: item.query('.diffinfo'),
+            open_node: item.ancestor().query('.diffinfo'),
             close_node: null,
-            source: source_url,
-            is_open: specific_path != null,
-            loading: item.query('.loading'),
-            node_process: node_process
+            source: null,
+            source_target: null,
+            is_open: true
           });
        item.collapsable=collapsable;
        });
-    if (window.location.hash && !specific_path) {
-      zoom_to_diff(window.location.hash.substring(1));
-    }
   });

=== modified file 'loggerhead/templatefunctions.py'
--- loggerhead/templatefunctions.py	2009-04-28 03:01:54 +0000
+++ loggerhead/templatefunctions.py	2009-03-07 07:29:26 +0000
@@ -38,31 +38,32 @@
 
 
 @templatefunc
-def file_change_summary(url, entry, file_changes, style='normal', currently_showing=None):
-    if style == 'fragment':
+def file_change_summary(url, entry, link_style='normal', currently_showing=None):
+    if link_style == 'fragment':
         def file_link(filename):
-            if currently_showing and filename == currently_showing:
-                return '<b><a href="#%s">%s</a></b>' % (
+            if currently_showing:
+                if filename == currently_showing:
+                    return '<b><a href="#%s">%s</a></b>' % (
+                        cgi.escape(filename), cgi.escape(filename))
+                else:
+                    return revision_link(url, entry.revno, filename)
+            else:
+                return '<a href="#%s">%s</a>' % (
                     cgi.escape(filename), cgi.escape(filename))
-            else:
-                return revision_link(
-                    url, entry.revno, filename, '#' + filename)
     else:
-        def file_link(filename):
-            return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>'%(
-                url(['/revision', entry.revno]), '#' + filename, cgi.escape(filename),
-                cgi.escape(entry.revno), cgi.escape(filename))
+        file_link = lambda filename: revision_link(url, entry.revno, filename)
     return _pt('revisionfilechanges').expand(
-        entry=entry, file_changes=file_changes, file_link=file_link, **templatefunctions)
+        url=url, entry=entry, file_link=file_link,
+        currently_showing=currently_showing, **templatefunctions)
 
 
 @templatefunc
-def revisioninfo(url, branch, entry, file_changes=None, currently_showing=None, merged_in=None):
+def revisioninfo(url, branch, entry, include_file_list=False, currently_showing=None):
     from loggerhead import util
     return _pt('revisioninfo').expand(
         url=url, change=entry, branch=branch, util=util,
-        file_changes=file_changes, currently_showing=currently_showing,
-        merged_in=merged_in, **templatefunctions)
+        include_file_list=include_file_list, currently_showing=currently_showing,
+        **templatefunctions)
 
 
 @templatefunc
@@ -119,7 +120,7 @@
         url(['/annotate', revno, path]), cgi.escape(path), cgi.escape(path))
 
 @templatefunc
-def revision_link(url, revno, path, frag=''):
-    return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>'%(
-        url(['/revision', revno, path]), frag, cgi.escape(path),
-        cgi.escape(revno), cgi.escape(path))
+def revision_link(url, revno, path):
+    return '<a href="%s" title="View changes to %s in revision %s">%s</a>'%(
+        url(['/revision', revno, path]), cgi.escape(path), cgi.escape(revno),
+        cgi.escape(path))

=== modified file 'loggerhead/templates/annotate.pt'
--- loggerhead/templates/annotate.pt	2009-03-06 09:57:54 +0000
+++ loggerhead/templates/annotate.pt	2009-03-02 00:10:26 +0000
@@ -65,7 +65,7 @@
               <a tal:condition="python:line.status=='changed'"
                  tal:content="python:util.trunc(line.change.revno)"
                  tal:attributes="href python:url(['/revision', line.change.revno], clear=1);
-                                 title python:'%s by %s, on %s (%s)'%(line.change.revno, ', '.join(util.hide_emails(line.change.authors)), line.change.date.strftime('%d %b %Y %H:%M'), util.date_time(line.change.date))"></a>
+                                 title python:'%s by %s, on %s (%s)'%(line.change.revno, util.hide_email(line.change.author), line.change.date.strftime('%d %b %Y %H:%M'), util.date_time(line.change.date))"></a>
             </td>
             <td class="annoCont"><pre tal:content="structure line/text"></pre></td>
           </tr>

=== modified file 'loggerhead/templates/atom.pt'
--- loggerhead/templates/atom.pt	2009-03-06 09:57:54 +0000
+++ loggerhead/templates/atom.pt	2008-06-26 20:42:15 +0000
@@ -17,8 +17,8 @@
     <id tal:content="python:branch.url(['/revision', entry.revno])">
       ID
     </id>
-    <author tal:repeat="author entry/authors">
-      <name tal:content="python:util.hide_email(author)">
+    <author>
+      <name tal:content="python:util.hide_email(entry.author)">
         author
       </name>
     </author>

=== modified file 'loggerhead/templates/browse.pt'
--- loggerhead/templates/browse.pt	2009-05-13 13:14:04 +0000
+++ loggerhead/templates/browse.pt	2008-10-18 00:23:09 +0000
@@ -43,12 +43,12 @@
                   </a>
                 </td>
               </tr>
-              <tr tal:condition="view/served_url">
+              <tr tal:condition="view/branch_url">
                 <td class="name">
                 </td>
                 <td class="description url" colspan="2">
-                  <a tal:attributes="href view/served_url"
-                     tal:content="view/served_url" />
+                  <a tal:attributes="href view/branch_url"
+                     tal:content="view/branch_url" />
                 </td>
               </tr>
             </tal:block>

=== modified file 'loggerhead/templates/changelog.pt'
--- loggerhead/templates/changelog.pt	2009-03-31 21:15:48 +0000
+++ loggerhead/templates/changelog.pt	2009-03-16 03:05:49 +0000
@@ -72,7 +72,7 @@
           <td class="revisionnumber">Rev</td>
           <td class="expandcell show_if_js">&nbsp;</td>
           <td class="summarycell">Summary</td>
-          <td class="authorcell">Authors</td>
+          <td class="authorcell">Author</td>
           <td class="datecell">Date</td>
           <td class="diffcell">Diff</td>
           <td class="downloadcell">Files</td>
@@ -86,30 +86,41 @@
             </td>
             <td class="expcell show_if_js">
               <div class="expand_revisioninfo">
+                <!-- So, this is interesting. I'm using "alt" to have the correct URL for the image of the expanded icon
+                     and "title" tag for the contracted URL of the image. This is a bit of a hack, but it's better than
+                     other approaches I tried  :)  -->
                 <a href="#">
-                  <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')"
+                  <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png');
+                                       alt python:branch.static_url('/static/images/treeExpanded.png');
+                                       title python:branch.static_url('/static/images/treeCollapsed.png')"
                        class="expand_icon" />
                 </a>
               </div>
             </td>
             <td class="summcell">
-              <div class="short_description">
-                <a tal:attributes="title python:'Show revision '+entry.revno;
-                                   href  python:url(['/revision', entry.revno], clear=1);
-                                   class string:link"
-                   tal:content="entry/short_comment"></a>
-              </div>
-              <div class="long_description" style="display: none">
-                <a tal:attributes="title python:'Show revision '+entry.revno;
-                                   href  python:url(['/revision', entry.revno], clear=1);
-                                   class string:link"
-                   tal:content="structure python:util.fixed_width(entry.comment)"></a>
-                <div class="loading">
-                  <img tal:attributes="src python:branch.static_url('/static/images/spinner.gif')" />
+              <div style="overflow: hidden">
+                <div class="container">
+                  <div class="short_description">
+                    <a tal:attributes="title python:'Show revision '+entry.revno;
+                                       href  python:url(['/revision', entry.revno], clear=1);
+                                       class string:link"
+                       tal:content="entry/short_comment"></a>
+                    <div class="loading" style="display:none;">
+                      <img tal:attributes="src python:branch.static_url('/static/images/spinner.gif')" />
+                    </div>
+                  </div>
+                  <div class="long_description" style="display: none">
+                    <a tal:attributes="title python:'Show revision '+entry.revno;
+                                       href  python:url(['/revision', entry.revno], clear=1);
+                                       class string:link"
+                       tal:content="structure python:util.fixed_width(entry.comment)"></a>
+                    <div class="source_target">
+                    </div>
+                  </div>
                 </div>
               </div>
             </td>
-            <td tal:content="python:util.trunc(util.hide_email(entry.authors[0]), 20)"
+            <td tal:content="python:util.trunc(util.hide_email(entry.author), 20)"
                 class="autcell"></td>
             <td class="date">
               <span tal:attributes="title python:util.date_time(entry.date)"

=== removed file 'loggerhead/templates/filediff.pt'
--- loggerhead/templates/filediff.pt	2009-04-01 15:28:21 +0000
+++ loggerhead/templates/filediff.pt	1970-01-01 00:00:00 +0000
@@ -1,25 +0,0 @@
-<div>
-  <div class="pseudotable unified"
-       tal:repeat="chunk chunks">
-
-    <tal:block condition="not:repeat/chunk/start">
-      <div class="pseudorow context-row">
-        <div class="lineNumber separate"></div>
-        <div class="lineNumber second separate"></div>
-        <div class="code separate"></div>
-        <div class="clear"><!-- --></div>
-      </div>
-    </tal:block>
-
-    <div tal:repeat="line chunk/diff"
-         tal:attributes="class string:pseudorow ${line/type}-row">
-      <div class="lineNumber first"
-           tal:content="structure python:util.fill_div(line.old_lineno)"></div>
-      <div class="lineNumber second"
-           tal:content="structure python:util.fill_div(line.new_lineno)"></div>
-      <div tal:attributes="class string:code ${line/type}"
-           tal:content="structure python:util.fill_div(util.html_clean(line.line))"></div>
-      <div class="clear"><!-- --></div>
-    </div>
-  </div>
-</div>

=== modified file 'loggerhead/templates/macros.pt'
--- loggerhead/templates/macros.pt	2009-04-07 18:26:03 +0000
+++ loggerhead/templates/macros.pt	2009-03-16 03:22:02 +0000
@@ -13,27 +13,37 @@
     </tal:comment>
     <script type="text/javascript">
       var global_path = <tal:block content="python:'\''+branch.url('/')+'\''" />;
-      var collapsed_icon_path = <tal:block content="python:'\''+branch.static_url('/static/images/treeCollapsed.png')+'\''" />;
-      var expanded_icon_path = <tal:block content="python:'\''+branch.static_url('/static/images/treeExpanded.png')+'\''" />;
     </script>
     <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('yui/yui-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('oop/oop-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('event/event-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('attribute/attribute-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('base/base-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('dom/dom-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('node/node-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('anim/anim-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('io/io-base-min.js')"></script>
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/yui/yui-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/oop/oop-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/event/event-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/attribute/attribute-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/base/base-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/dom/dom-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/node/node-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/anim/anim-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/io/io-base-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/io/io-queue-min.js')"></script>
     <script type="text/javascript"
             tal:attributes="src python:branch.static_url('/static/javascript/custom.js')"></script>
     <metal:block metal:define-slot="header_extras" />

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2009-04-28 03:01:54 +0000
+++ loggerhead/templates/revision.pt	2009-03-16 06:44:50 +0000
@@ -11,11 +11,6 @@
               tal:attributes="href python:branch.static_url('/static/css/diff.css')"/>
         <script type="text/javascript"
                 tal:attributes="src python:branch.static_url('/static/javascript/diff.js')"></script>
-        <script type="text/javascript">
-          var link_data = <tal:b content="link_data" />;
-          var specific_path = <tal:b content="json_specific_path" />;
-          var path_to_id = <tal:b content="path_to_id" />;
-        </script>
       </metal:block>
     </head>
 
@@ -96,17 +91,15 @@
           </ul>
         </tal:we-are-comparing>
 
-        <tal:revision-info replace="structure python:revisioninfo(url, branch, change, file_changes, specific_path, merged_in)" />
-        <tal:specific-path condition="not:specific_path">
-          <p class="expand show_if_js" id="expand_all"><a href="#">
-              <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')"
-                   alt="expand all" /> expand all</a>
-          </p>
-          <p class="expand" id="collapse_all" style="display:none;"><a href="#">
-              <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png')"
-                   alt="collapse all" /> collapse all</a>
-          </p>
-        </tal:specific-path>
+        <tal:revision-info replace="structure python:revisioninfo(url, branch, change, 'fragment', specific_path)" />
+        <p class="expand" id="expand_all" style="display:none;"><a href="#">
+            <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')"
+                 alt="expand all" /> expand all</a>
+        </p>
+        <p class="expand show_if_js" id="collapse_all"><a href="#">
+            <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png')"
+                 alt="collapse all" /> collapse all</a>
+        </p>
         <!-- Table -->
         <p class="expand show_if_js"><a id="toggle_unified_sbs" href="#">Show diffs side-by-side</a></p>
         <p class="codin"><img tal:attributes="src python:branch.static_url('/static/images/newCode.gif')" alt="added" /> added</p>
@@ -116,75 +109,50 @@
       </tal:block>
 
       <div metal:fill-slot="content">
-        <tal:block condition="specific_path">
-          <div class="diff">
-
-            <div  class="diffBox">
-              <a tal:attributes="href python:url(['/revision', change.revno, specific_path], clear=1);
-                                 id string:${specific_path};
-                                 title string:View changes to ${specific_path} only"
-                 class="the-link">
-                <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png')"
-                     class="expand_diff"/>
-                <tal:b content="specific_path" />
-              </a>
-            </div>
-            <div style="overflow: hidden">
-              <div class="container">
-                <div class="loading" style="display:none">
-                  <img tal:attributes="src python:branch.static_url('/static/images/spinner.gif')" />
-                </div>
-                <div class="diffinfo">
-                  <div class="pseudotable unified"
-                       tal:repeat="chunk diff_chunks">
-
-                    <tal:block condition="not:repeat/chunk/start">
-                      <div class="pseudorow context-row">
-                        <div class="lineNumber separate"></div>
-                        <div class="lineNumber second separate"></div>
-                        <div class="code separate"></div>
-                        <div class="clear"><!-- --></div>
-                      </div>
-                    </tal:block>
-
-                    <div tal:repeat="line chunk/diff"
-                         tal:attributes="class string:pseudorow ${line/type}-row">
-                      <div class="lineNumber first"
-                           tal:content="structure python:util.fill_div(line.old_lineno)"></div>
-                      <div class="lineNumber second"
-                           tal:content="structure python:util.fill_div(line.new_lineno)"></div>
-                      <div tal:attributes="class string:code ${line/type}"
-                           tal:content="structure python:util.fill_div(util.html_clean(line.line))"></div>
+        <div class="diff"
+             tal:repeat="item diffs">
+
+          <div class="diffBox">
+            <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png');
+                                 title python:branch.static_url('/static/images/treeCollapsed.png');
+                                 alt python:branch.static_url('/static/images/treeExpanded.png')"
+                 class="expand_diff" />
+            <a tal:attributes="href python:url(['/revision', change.revno, item.filename], clear=1);
+                               id string:${item/filename};
+                               title string:View changes to ${item/filename} only"
+               tal:content="item/filename">
+            </a>
+          </div>
+          <div style="overflow: hidden">
+            <div class="container">
+              <div class="diffinfo">
+                <div class="pseudotable unified"
+                     tal:repeat="chunk item/chunks">
+
+                  <tal:block condition="not:repeat/chunk/start">
+                    <div class="pseudorow context-row">
+                      <div class="lineNumber separate"></div>
+                      <div class="lineNumber second separate"></div>
+                      <div class="code separate"></div>
                       <div class="clear"><!-- --></div>
                     </div>
+                  </tal:block>
+
+                  <div tal:repeat="line chunk/diff"
+                       tal:attributes="class string:pseudorow ${line/type}-row">
+                    <div class="lineNumber first"
+                         tal:content="structure python:util.fill_div(line.old_lineno)"></div>
+                    <div class="lineNumber second"
+                         tal:content="structure python:util.fill_div(line.new_lineno)"></div>
+                    <div tal:attributes="class string:code ${line/type}"
+                         tal:content="structure python:util.fill_div(util.html_clean(line.line))"></div>
+                    <div class="clear"><!-- --></div>
                   </div>
                 </div>
               </div>
             </div>
           </div>
-        </tal:block>
-
-        <tal:block condition="not:specific_path">
-          <div class="diff"
-               tal:repeat="item file_changes/text_changes" tal:attributes="id string:diff-${item/index}">
-
-            <div  class="diffBox">
-              <a tal:attributes="href python:url(['/revision', change.revno, item.filename], clear=1);
-                                 id string:${item/filename};
-                                 title string:View changes to ${item/filename} only"
-                 class="the-link">
-                <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')"
-                     class="expand_diff" />
-                <tal:b content="item/filename" />
-              </a>
-            </div>
-            <div class="diffinfo"  style="display:none">
-              <div class="loading">
-                <img tal:attributes="src python:branch.static_url('/static/images/spinner.gif')" />
-              </div>
-            </div>
-          </div>
-        </tal:block>
+        </div>
 
         <ul tal:condition="python:navigation.prev_page_revid or navigation.next_page_revid"
             id="pages">

=== modified file 'loggerhead/templates/revisionfilechanges.pt'
--- loggerhead/templates/revisionfilechanges.pt	2009-03-19 00:05:41 +0000
+++ loggerhead/templates/revisionfilechanges.pt	2009-03-05 23:41:51 +0000
@@ -1,5 +1,5 @@
 <tal:block>
-  <ul tal:repeat="added file_changes/added">
+  <ul tal:repeat="added entry/changes/added">
     <tal:block condition="repeat/added/start">
       <li class="desc">files added:</li>
     </tal:block>
@@ -11,7 +11,7 @@
     </li>
   </ul>
 
-  <ul tal:repeat="removed file_changes/removed">
+  <ul tal:repeat="removed entry/changes/removed">
     <tal:block condition="repeat/removed/start">
       <li class="desc">files removed:</li>
     </tal:block>
@@ -23,7 +23,7 @@
     </li>
   </ul>
 
-  <ul tal:repeat="renamed file_changes/renamed">
+  <ul tal:repeat="renamed entry/changes/renamed">
     <tal:block condition="repeat/renamed/start">
       <li class="desc">files renamed:</li>
     </tal:block>
@@ -39,7 +39,7 @@
     </li>
   </ul>
 
-  <ul tal:repeat="item file_changes/modified">
+  <ul tal:repeat="item entry/changes/modified">
     <tal:block condition="repeat/item/start">
       <li class="desc">files modified:</li>
     </tal:block>

=== modified file 'loggerhead/templates/revisioninfo.pt'
--- loggerhead/templates/revisioninfo.pt	2009-05-30 17:40:05 +0000
+++ loggerhead/templates/revisioninfo.pt	2009-03-05 22:56:59 +0000
@@ -1,6 +1,6 @@
 <div class="infoContainer">
     <div id="infTxt">
-        <div class="committer" tal:content="python:', '.join(util.hide_emails(change.authors))"></div>
+        <div class="committer" tal:content="python:util.hide_email(change.author)"></div>
         <div class="timer" tal:content="python:util.date_time(change.date)"></div>
         <div class="mfrom" tal:repeat="parent python:change.parents[1:]">
             <a tal:attributes="title string:Merged From ${parent/revno};
@@ -12,20 +12,11 @@
                                href python:url(['/revision', merge_point.revno], clear=1)"
                tal:content="python:revno_with_nick(merge_point)"></a>
         </div>
-        <div class="mto" tal:condition="merged_in">
-          This revision was merged to the branch mainline in
-          <a tal:attributes="href python:url(['/revision', merged_in], clear=1)">revision
-            <tal:b content="merged_in"/></a>.
-        </div>
         <div class="revid" tal:content="string:Revision ID: ${change/revid}"></div>
-        <div class="clear"><!-- --></div>
-        <div class="bug" tal:repeat="bug change/bugs">
-            <a tal:attributes="href bug" tal:content="bug"></a>
-        </div>
         <div class="information" tal:content="structure python:util.fixed_width(change.comment)"></div>
     </div>
-    <ul id="list-files" tal:condition="file_changes">
-      <tal:block content="structure python:file_change_summary(url, change, file_changes, 'fragment', currently_showing)" />
+    <ul id="list-files" tal:condition="include_file_list">
+      <tal:block content="structure python:file_change_summary(url, change, 'fragment', currently_showing)" />
     </ul>
     <div class="clear"><!-- --></div>
 </div>

=== modified file 'loggerhead/templates/revlog.pt'
--- loggerhead/templates/revlog.pt	2009-03-31 15:23:54 +0000
+++ loggerhead/templates/revlog.pt	2009-03-13 05:36:26 +0000
@@ -3,15 +3,19 @@
     <li class="mfrom" tal:repeat="parent python:entry.parents[1:]">
       <span class="revnolink">
         <a tal:attributes="href python:url(['/changes', parent.revno])"
-           tal:content="python:revno_with_nick(parent)"></a>
+           tal:content="parent/revno"></a>
       </span>
+      <a tal:condition="parent.branch_nick"
+         tal:attributes="href python:url(['/changes'], start_revid=parent.revno)"
+         tal:content="python:'(' + parent.branch_nick + ')'"
+         title="Show history" class="link"></a>
     </li>
     <li class="mto" tal:repeat="merge_point entry/merge_points">
-      <a tal:attributes="href python:url(['/changes', merge_point.revno])"
+      <a tal:attributes="href python:url(['/changes'], start_revid=merge_point.revno)"
          tal:content="python:revno_with_nick(merge_point)"
          title="Show history" class="link"></a>
     </li>
-    <li class="committerli" tal:content="python:', '.join(util.hide_emails(entry.authors))"></li>
-    <tal:block content="structure python:file_change_summary(url, entry, file_changes)" />
+    <li class="committerli" tal:content="python:util.hide_email(entry.author)"></li>
+    <tal:block content="structure python:file_change_summary(url, entry)" />
   </ul>
 </div>

=== modified file 'loggerhead/tests/test_controllers.py'
--- loggerhead/tests/test_controllers.py	2009-03-19 18:48:15 +0000
+++ loggerhead/tests/test_controllers.py	2009-02-26 06:31:24 +0000
@@ -53,9 +53,24 @@
         rev_ui.args = ['2']
         util.set_context({})
         self.assertIsInstance(
-            rev_ui.get_values('', {}, []),
+            rev_ui.get_values('2', {}, []),
             dict)
 
+    def test_get_changes_with_diff(self):
+        branch, rev_ui = self.make_bzrbranch_and_revision_ui_for_tree_shapes(
+            [('file', 'oldcontents'), ('file2', 'oldcontents')],
+            [('file', 'newcontents'), ('file2', 'oldcontents')])
+        change = rev_ui._history.get_changes([branch.last_revision()])[0]
+        changes, diffs = rev_ui.get_changes_with_diff(change, None, None)
+        self.assertEqual(1, len(diffs))
+
+    def test_get_changes_with_diff_specific_path(self):
+        branch, rev_ui = self.make_bzrbranch_and_revision_ui_for_tree_shapes(
+            [('file', 'oldcontents'), ('file2', 'oldcontents')],
+            [('file', 'newcontents'), ('file2', 'newcontents')])
+        change = rev_ui._history.get_changes([branch.last_revision()])[0]
+        changes, diffs = rev_ui.get_changes_with_diff(change, None, 'file')
+        self.assertEqual(1, len(diffs))
 
 class TestAnnotateUI(BasicTests):
 

=== modified file 'loggerhead/tests/test_corners.py'
--- loggerhead/tests/test_corners.py	2009-04-02 20:32:12 +0000
+++ loggerhead/tests/test_corners.py	2009-03-16 18:54:39 +0000
@@ -34,16 +34,6 @@
         res = app.get('/revision/'+newrevid)
         res.mustcontain('executable')
 
-    def test_revision_escapes_commit_message(self):
-        """XXX."""
-        self.createBranch()
-
-        msg = '<b>hi</b>'
-        self.addFileAndCommit('myfilename', msg)
-        app = self.setUpLoggerhead()
-        res = app.get('/revision/1')
-        self.assertFalse(msg in res.body)
-
     def test_empty_commit_message(self):
         """Check that an empty commit message does not break the rendering."""
         self.createBranch()

=== added file 'loggerhead/tests/test_filechangecache.py'
--- loggerhead/tests/test_filechangecache.py	1970-01-01 00:00:00 +0000
+++ loggerhead/tests/test_filechangecache.py	2008-10-24 02:26:05 +0000
@@ -0,0 +1,98 @@
+"""Tests for the FileChangeCache in loggerhead.changecache."""
+
+import shutil
+import tempfile
+
+from loggerhead.changecache import FileChangeCache
+
+
+class MockEntry(object):
+
+    def __init__(self, revid):
+        self.revid = revid
+
+
+class MockHistory(object):
+
+    def __init__(self):
+        self.fetched_revids = set()
+
+    def get_file_changes_uncached(self, entries):
+        output = []
+        for entry in entries:
+            self.fetched_revids.add(entry.revid)
+            output.append(entry.revid)
+        return output
+
+
+class TestFileChangeCache(object):
+
+    # setup_method and teardown_method are so i can run the tests with
+    # py.test and take advantage of the error reporting.
+
+    def setup_method(self, meth):
+        self.setUp()
+
+    def teardown_method(self, meth):
+        self.tearDown()
+
+    def setUp(self):
+        self.cache_folders = []
+
+    def tearDown(self):
+        for folder in self.cache_folders:
+            shutil.rmtree(folder)
+
+    def makeHistoryAndEntriesForRevids(self, revids, fill_cache_with=[]):
+        cache_folder = tempfile.mkdtemp()
+        self.cache_folders.append(cache_folder)
+        self.history = MockHistory()
+        self.cache = FileChangeCache(self.history, cache_folder)
+
+        self.entries = [MockEntry(revid) for revid in revids]
+
+        self.cache.get_file_changes([entry for entry in self.entries
+                                     if entry.revid in fill_cache_with])
+        self.history.fetched_revids.clear()
+
+    def test_empty_cache(self):
+        """An empty cache passes all the revids through to the history object.
+        """
+        revids = ['a', 'b']
+        self.makeHistoryAndEntriesForRevids(revids)
+
+        result = self.cache.get_file_changes(self.entries)
+
+        assert result == revids
+        assert self.history.fetched_revids == set(revids)
+
+    def test_full_cache(self):
+        """A full cache passes none of the revids through to the history
+        object.
+        """
+        revids = ['a', 'b']
+        self.makeHistoryAndEntriesForRevids(revids, fill_cache_with=revids)
+
+        result = self.cache.get_file_changes(self.entries)
+
+        assert result == revids
+        assert self.history.fetched_revids == set()
+
+    def test_partial_cache(self):
+        """A partially full cache passes some of the revids through to the
+        history object, and preserves the ordering of the argument list.
+        """
+        # To test the preservation of argument order code, we put the uncached
+        # revid at the beginning, middle and then end of the list of revids
+        # being asked for.
+        for i in range(3):
+            cached_revids = ['a', 'b']
+            revids = cached_revids[:]
+            revids.insert(i, 'uncached')
+            self.makeHistoryAndEntriesForRevids(
+                revids, fill_cache_with=cached_revids)
+
+            result = self.cache.get_file_changes(self.entries)
+            assert result == revids
+
+            assert self.history.fetched_revids == set(['uncached'])

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2009-04-02 20:32:12 +0000
+++ loggerhead/util.py	2009-03-03 21:39:54 +0000
@@ -181,14 +181,6 @@
         return '%s at %s' % (username, domains[-2])
     return '%s at %s' % (username, domains[0])
 
-def hide_emails(emails):
-    """
-    try to obscure any email address in a list of bazaar committers' names.
-    """
-    result = []
-    for email in emails:
-        result.append(hide_email(email))
-    return result
 
 # only do this if unicode turns out to be a problem
 #_BADCHARS_RE = re.compile(ur'[\u007f-\uffff]')
@@ -250,7 +242,7 @@
         except UnicodeDecodeError:
             s = s.decode('iso-8859-15')
 
-    s = cgi.escape(s).expandtabs().replace(' ', NONBREAKING_SPACE)
+    s = s.expandtabs().replace(' ', NONBREAKING_SPACE)
 
     return HSC.clean(s).replace('\n', '<br/>')
 
@@ -449,6 +441,25 @@
     return new_decorator
 
 
+# common threading-lock decorator
+
+
+def with_lock(lockname, debug_name=None):
+    if debug_name is None:
+        debug_name = lockname
+
+    @decorator
+    def _decorator(unbound):
+
+        def locked(self, *args, **kw):
+            getattr(self, lockname).acquire()
+            try:
+                return unbound(self, *args, **kw)
+            finally:
+                getattr(self, lockname).release()
+        return locked
+    return _decorator
+
 
 @decorator
 def lsprof(f):

=== modified file 'loggerhead/wholehistory.py'
--- loggerhead/wholehistory.py	2009-05-18 04:17:11 +0000
+++ loggerhead/wholehistory.py	2008-12-05 20:09:14 +0000
@@ -37,10 +37,6 @@
 
 
 def compute_whole_history_data(branch):
-    """Compute _rev_info and _rev_indices for a branch.
-
-    See History.__doc__ for what these data structures mean.
-    """
     z = time.time()
 
     last_revid = branch.last_revision()
@@ -53,31 +49,31 @@
          graph.iter_ancestry([last_revid]) if value is not None))
 
     _revision_graph = _strip_NULL_ghosts(parent_map)
-
-    _rev_info = []
-    _rev_indices = {}
-
+    _full_history = []
+    _revision_info = {}
+    _revno_revid = {}
     if is_null(last_revid):
         _merge_sort = []
     else:
         _merge_sort = merge_sort(
             _revision_graph, last_revid, generate_revno=True)
 
-    for info in _merge_sort:
-        seq, revid, merge_depth, revno, end_of_merge = info
+    for (seq, revid, merge_depth, revno, end_of_merge) in _merge_sort:
+        _full_history.append(revid)
         revno_str = '.'.join(str(n) for n in revno)
-        parents = _revision_graph[revid]
-        _rev_indices[revid] = len(_rev_info)
-        _rev_info.append([(seq, revid, merge_depth, revno_str, end_of_merge), (), parents])
+        _revno_revid[revno_str] = revid
+        _revision_info[revid] = (
+            seq, revid, merge_depth, revno_str, end_of_merge)
+
+    _where_merged = {}
 
     for revid in _revision_graph.keys():
-        if _rev_info[_rev_indices[revid]][0][2] == 0:
+        if _revision_info[revid][2] == 0:
             continue
         for parent in _revision_graph[revid]:
-            c = _rev_info[_rev_indices[parent]]
-            if revid not in c[1]:
-                c[1] = c[1] + (revid,)
+            _where_merged.setdefault(parent, set()).add(revid)
 
     log.info('built revision graph cache: %r secs' % (time.time() - z))
 
-    return (_rev_info, _rev_indices)
+    return (_revision_graph, _full_history, _revision_info,
+            _revno_revid, _merge_sort, _where_merged)

=== modified file 'serve-branches'
--- serve-branches	2009-05-04 20:21:08 +0000
+++ serve-branches	2009-02-24 21:13:30 +0000
@@ -19,65 +19,96 @@
 import os
 import sys
 
+from optparse import OptionParser
+
 from bzrlib.plugin import load_plugins
-from bzrlib.transport import get_transport
 
 from paste import httpserver
 from paste.httpexceptions import HTTPExceptionHandler, HTTPInternalServerError
 from paste.translogger import TransLogger
 
 from loggerhead import __version__
-from loggerhead.apps.transport import (
-    BranchesFromTransportRoot, UserBranchesFromTransportRoot)
-from loggerhead.config import LoggerheadConfig
+from loggerhead.apps.filesystem import (
+    BranchesFromFileSystemRoot, UserBranchesFromFileSystemRoot)
 from loggerhead.util import Reloader
 from loggerhead.apps.error import ErrorHandlerApp
 
 
+def command_line_parser():
+    parser = OptionParser("%prog [options] <path>")
+    parser.set_defaults(
+        user_dirs=False,
+        show_version=False,
+        log_folder=None,
+        )
+    parser.add_option("--user-dirs", action="store_true", dest="user_dirs",
+                      help="Serve user directories as ~user.")
+    parser.add_option("--trunk-dir", metavar="DIR",
+                      help="The directory that contains the trunk branches.")
+    parser.add_option("--port", dest="user_port",
+                      help=("Port Loggerhead should listen on "
+                            "(defaults to 8080)."))
+    parser.add_option("--host", dest="user_host",
+                      help="Host Loggerhead should listen on.")
+    parser.add_option("--prefix", dest="user_prefix",
+                      help="Specify host prefix.")
+    parser.add_option("--profile", action="store_true", dest="profile",
+                      help="Generate callgrind profile data to "
+                        "%d-stats.callgrind on each request.")
+    parser.add_option("--reload", action="store_true", dest="reload",
+                      help="Restarts the application when changing python"
+                           " files. Only used for development purposes.")
+    parser.add_option('--log-folder', dest="log_folder",
+                      type=str, help="The directory to place log files in.")
+    parser.add_option("--version", action="store_true", dest="show_version",
+                      help="Print the software version and exit")
+    return parser
+
+
 def main(args):
-    config = LoggerheadConfig()
+    parser = command_line_parser()
+    (options, args) = parser.parse_args(sys.argv[1:])
 
-    if config.get_option('show_version'):
+    if options.show_version:
         print "loggerhead %s" % __version__
         sys.exit(0)
 
-    if config.arg_count > 1:
-        config.print_help()
+    if len(args) > 1:
+        parser.print_help()
         sys.exit(1)
-    elif config.arg_count == 1:
-        path = config.get_arg(0)
+    elif len(args) == 1:
+        [path] = args
     else:
         path = '.'
 
-    load_plugins()
-
-    transport = get_transport(path)
-
-    if config.get_option('trunk_dir') and not config.get_option('user_dirs'):
+    if not os.path.isdir(path):
+        print "%s is not a directory" % path
+        sys.exit(1)
+
+    if options.trunk_dir and not options.user_dirs:
         print "--trunk-dir is only valid with --user-dirs"
         sys.exit(1)
 
-    if config.get_option('reload'):
+    if options.reload:
         if Reloader.is_installed():
             Reloader.install()
         else:
             return Reloader.restart_with_reloader()
 
-    if config.get_option('user_dirs'):
-        if not config.get_option('trunk_dir'):
+    if options.user_dirs:
+        if not options.trunk_dir:
             print "You didn't specify a directory for the trunk directories."
             sys.exit(1)
-        app = UserBranchesFromTransportRoot(transport, config)
+        app = UserBranchesFromFileSystemRoot(path, options.trunk_dir)
     else:
-        app = BranchesFromTransportRoot(transport, config)
+        app = BranchesFromFileSystemRoot(path)
 
     # setup_logging()
     logging.basicConfig()
     logging.getLogger('').setLevel(logging.DEBUG)
     logger = getattr(app, 'log', logging.getLogger('loggerhead'))
-    if config.get_option('log_folder'):
-        logfile_path = os.path.join(
-            config.get_option('log_folder'), 'serve-branches.log')
+    if options.log_folder:
+        logfile_path = os.path.join(options.log_folder, 'serve-branches.log')
     else:
         logfile_path = 'serve-branches.log'
     logfile = logging.FileHandler(logfile_path, 'a')
@@ -86,21 +117,16 @@
     logfile.setFormatter(formatter)
     logfile.setLevel(logging.DEBUG)
     logger.addHandler(logfile)
-
     # setup_logging() #end
-
     app = TransLogger(app, logger=logger)
-    if config.get_option('profile'):
+    if options.profile:
         from loggerhead.middleware.profile import LSProfMiddleware
         app = LSProfMiddleware(app)
-    if config.get_option('memory_profile'):
-        from dozer import Dozer
-        app = Dozer(app)
 
-    if not config.get_option('user_prefix'):
+    if not options.user_prefix:
         prefix = '/'
     else:
-        prefix = config.get_option('user_prefix')
+        prefix = options.user_prefix
         if not prefix.startswith('/'):
             prefix = '/' + prefix
 
@@ -125,15 +151,17 @@
     app = HTTPExceptionHandler(app)
     app = ErrorHandlerApp(app)
 
-    if not config.get_option('user_port'):
+    if not options.user_port:
         port = '8080'
     else:
-        port = config.get_option('user_port')
+        port = options.user_port
 
-    if not config.get_option('user_host'):
+    if not options.user_host:
         host = '0.0.0.0'
     else:
-        host = config.get_option('user_host')
+        host = options.user_host
+
+    load_plugins()
 
     httpserver.serve(app, host=host, port=port)
 

=== modified file 'setup.py' (properties changed: +x to -x)
--- setup.py	2009-06-02 22:10:00 +0000
+++ setup.py	2008-11-20 16:55:47 +0000
@@ -34,9 +34,7 @@
     packages = ["loggerhead",
                 "loggerhead/apps",
                 "loggerhead/controllers",
-                "loggerhead/templates",
-                "bzrlib.plugins.loggerhead"],
-    package_dir={'bzrlib.plugins.loggerhead':'.'},
+                "loggerhead/templates"],
     package_data = {"loggerhead": ["templates/*.pt",
                                    "static/css/*.css",
                                    "static/javascript/*.js",

